// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AdvChart.pas' rev: 6.00

#ifndef AdvChartHPP
#define AdvChartHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <IniFiles.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <DateUtils.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Advchart
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TVerticalAlignment { taAlignTop, taAlignBottom, taVerticalCenter };
#pragma option pop

#pragma pack(push, 4)
struct TChartSeriePoint
{
	int Serie;
	int Point;
} ;
#pragma pack(pop)

#pragma option push -b-
enum TChartBorderStyle { cbLeft, cbTop, cbRight, cbBottom };
#pragma option pop

typedef Set<TChartBorderStyle, cbLeft, cbBottom>  TChartBorderStyles;

#pragma option push -b-
enum TChartBackGroundPosition { bpTopLeft, bpTopRight, bpBottomLeft, bpBottomRight, bpTiled, bpStretched, bpCenter };
#pragma option pop

#pragma option push -b-
enum TChartGradientDirection { cgdHorizontal, cgdVertical };
#pragma option pop

#pragma option push -b-
enum TChartYAxisPosition { yLeft, yRight, yBoth, yNone };
#pragma option pop

#pragma option push -b-
enum TChartXAxisPosition { xBottom, xTop, xBoth, xNone };
#pragma option pop

#pragma option push -b-
enum TTitlePosition { tTop, tBottom, tBoth, tNone };
#pragma option pop

#pragma option push -b-
enum TChartSeriePiePosition { spTopLeft, spTopRight, spTopCenter, spBottomLeft, spBottomRight, spBottomCenter, spCenterLeft, spCenterCenter, spCenterRight, spCustom };
#pragma option pop

#pragma option push -b-
enum TChartLegendAlignment { laTopLeft, laTopRight, laTopCenter, laCenterLeft, laCenterRight, laCenterCenter, laBottomLeft, laBottomRight, laBottomCenter, laCustom };
#pragma option pop

class DELPHICLASS TChartLegend;
class DELPHICLASS TAdvChart;
#pragma option push -b-
enum TChartAxisMode { amXAxisFullWidth, amYAxisFullHeight, amAxisChartWidthHeight };
#pragma option pop

class DELPHICLASS TChartBackground;
class PASCALIMPLEMENTATION TChartBackground : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TChartBackGroundPosition FBackgroundPosition;
	TChartGradientDirection FGradientDirection;
	int FGradientSteps;
	Graphics::TColor FColor;
	Graphics::TColor FColorTo;
	Graphics::TFont* FFont;
	Classes::TNotifyEvent FOnChange;
	TAdvChart* FOwner;
	Graphics::TPicture* FPicture;
	bool FPictureVisible;
	void __fastcall SetBackgroundPosition(const TChartBackGroundPosition Value);
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetColorTo(const Graphics::TColor Value);
	void __fastcall SetFont(const Graphics::TFont* Value);
	void __fastcall SetGradientDirection(const TChartGradientDirection Value);
	void __fastcall SetGradientSteps(const int Value);
	void __fastcall SetPicture(const Graphics::TPicture* Value);
	void __fastcall SetPictureVisible(const bool Value);
	
protected:
	void __fastcall FontChanged(System::TObject* Sender);
	void __fastcall PictureChanged(System::TObject* Sender);
	virtual void __fastcall Changed(void);
	
public:
	__fastcall virtual TChartBackground(TAdvChart* AOwner);
	__fastcall virtual ~TChartBackground(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	virtual void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	virtual void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property TChartBackGroundPosition BackGroundPosition = {read=FBackgroundPosition, write=SetBackgroundPosition, default=0};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=536870911};
	__property Graphics::TColor ColorTo = {read=FColorTo, write=SetColorTo, default=536870911};
	__property int GradientSteps = {read=FGradientSteps, write=SetGradientSteps, default=100};
	__property TChartGradientDirection GradientDirection = {read=FGradientDirection, write=SetGradientDirection, default=0};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Graphics::TPicture* Picture = {read=FPicture, write=SetPicture};
	__property bool PictureVisible = {read=FPictureVisible, write=SetPictureVisible, default=0};
};


class DELPHICLASS TChartBands;
class PASCALIMPLEMENTATION TChartBands : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	double FDistance;
	int FGradientSteps;
	TChartGradientDirection FGradientDirection;
	Classes::TNotifyEvent FOnChange;
	TAdvChart* FOwner;
	Graphics::TColor FPrimaryColor;
	Graphics::TColor FPrimaryColorTo;
	Graphics::TColor FSecondaryColor;
	Graphics::TColor FSecondaryColorTo;
	int FSerieIndex;
	bool FVisible;
	void __fastcall SetGradientDirection(const TChartGradientDirection Value);
	void __fastcall SetGradientSteps(const int Value);
	void __fastcall SetPrimaryColor(const Graphics::TColor Value);
	void __fastcall SetPrimaryColorTo(const Graphics::TColor Value);
	void __fastcall SetSecondaryColor(const Graphics::TColor Value);
	void __fastcall SetSecondaryColorTo(const Graphics::TColor Value);
	void __fastcall SetSerieIndex(const int Value);
	void __fastcall SetVisible(const bool Value);
	
protected:
	virtual void __fastcall Changed(void);
	
public:
	__fastcall TChartBands(TAdvChart* AOwner);
	__fastcall virtual ~TChartBands(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property double Distance = {read=FDistance, write=FDistance};
	__property int GradientSteps = {read=FGradientSteps, write=SetGradientSteps, default=100};
	__property TChartGradientDirection GradientDirection = {read=FGradientDirection, write=SetGradientDirection, default=0};
	__property Graphics::TColor PrimaryColor = {read=FPrimaryColor, write=SetPrimaryColor, default=12632256};
	__property Graphics::TColor PrimaryColorTo = {read=FPrimaryColorTo, write=SetPrimaryColorTo, default=16777215};
	__property Graphics::TColor SecondaryColor = {read=FSecondaryColor, write=SetSecondaryColor, default=8388608};
	__property Graphics::TColor SecondaryColorTo = {read=FSecondaryColorTo, write=SetSecondaryColorTo, default=16777215};
	__property bool Visible = {read=FVisible, write=SetVisible, default=0};
	__property int SerieIndex = {read=FSerieIndex, write=SetSerieIndex, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};


class DELPHICLASS TChartCrossHair;
#pragma option push -b-
enum TChartCrossHairType { chtNone, chtSmallCrossHair, chtFullSizeCrossHairAtCursor, chtFullSizeCrossHairAtSeries };
#pragma option pop

class DELPHICLASS TChartCrossHairYValues;
#pragma option push -b-
enum TChartCrossHairYValuePositionType { chYAxis, chAtCursor, chValueTracker };
#pragma option pop

typedef Set<TChartCrossHairYValuePositionType, chYAxis, chValueTracker>  TChartCrossHairYValuePosition;

class PASCALIMPLEMENTATION TChartCrossHairYValues : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FShowSerieValues;
	bool FShowYPosValue;
	TChartCrossHairYValuePosition FPosition;
	Classes::TNotifyEvent FOnChange;
	void __fastcall SetPosition(const TChartCrossHairYValuePosition Value);
	void __fastcall SetShowSerieValues(const bool Value);
	void __fastcall SetShowYPosValue(const bool Value);
	
protected:
	virtual void __fastcall Changed(void);
	
public:
	__fastcall TChartCrossHairYValues(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property bool ShowSerieValues = {read=FShowSerieValues, write=SetShowSerieValues, default=1};
	__property bool ShowYPosValue = {read=FShowYPosValue, write=SetShowYPosValue, default=0};
	__property TChartCrossHairYValuePosition Position = {read=FPosition, write=SetPosition, nodefault};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TChartCrossHairYValues(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TChartCrossHair : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FDistance;
	TChartCrossHairType FCrossHairType;
	TChartCrossHairYValues* FCrossHairYValues;
	Classes::TNotifyEvent FOnChange;
	TAdvChart* FOwner;
	Graphics::TColor FLineColor;
	int FLineWidth;
	bool FVisible;
	void __fastcall SetCrossHairType(const TChartCrossHairType Value);
	void __fastcall SetCrossHairYValues(const TChartCrossHairYValues* Value);
	void __fastcall SetDistance(const int Value);
	void __fastcall SetLineColor(const Graphics::TColor Value);
	void __fastcall SetLineWidth(const int Value);
	void __fastcall SetVisible(const bool Value);
	
protected:
	virtual void __fastcall Changed(void);
	void __fastcall CrossHairYValuesChanged(System::TObject* Sender);
	
public:
	__fastcall TChartCrossHair(TAdvChart* AOwner);
	__fastcall virtual ~TChartCrossHair(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property TChartCrossHairType CrossHairType = {read=FCrossHairType, write=SetCrossHairType, default=3};
	__property TChartCrossHairYValues* CrossHairYValues = {read=FCrossHairYValues, write=SetCrossHairYValues};
	__property int Distance = {read=FDistance, write=SetDistance, default=20};
	__property int LineWidth = {read=FLineWidth, write=SetLineWidth, default=1};
	__property Graphics::TColor LineColor = {read=FLineColor, write=SetLineColor, default=536870911};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property bool Visible = {read=FVisible, write=SetVisible, default=0};
};


class DELPHICLASS TChartMargin;
class PASCALIMPLEMENTATION TChartMargin : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FBottomMargin;
	int FLeftMargin;
	Classes::TNotifyEvent FOnChange;
	TAdvChart* FOwner;
	int FRightMargin;
	int FTopMargin;
	void __fastcall SetBottomMargin(const int Value);
	void __fastcall SetLeftMargin(const int Value);
	void __fastcall SetRightMargin(const int Value);
	void __fastcall SetTopMargin(const int Value);
	
protected:
	virtual void __fastcall Changed(void);
	
public:
	__fastcall TChartMargin(TAdvChart* AOwner);
	__fastcall virtual ~TChartMargin(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property int BottomMargin = {read=FBottomMargin, write=SetBottomMargin, default=0};
	__property int LeftMargin = {read=FLeftMargin, write=SetLeftMargin, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property int RightMargin = {read=FRightMargin, write=SetRightMargin, default=0};
	__property int TopMargin = {read=FTopMargin, write=SetTopMargin, default=0};
};


class DELPHICLASS TChartNavigator;
#pragma option push -b-
enum TChartNavigatorButtonState { cnbNormal, cnbHot, cnbDown };
#pragma option pop

class PASCALIMPLEMENTATION TChartNavigator : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Byte FAlphaBlendValue;
	bool FAlphaBlend;
	Graphics::TColor FColor;
	Graphics::TColor FColorTo;
	TChartGradientDirection FGradientDirection;
	int FGradientSteps;
	TAdvChart* FOwner;
	Classes::TNotifyEvent FOnChange;
	TChartNavigatorButtonState FLeftButtonState;
	TChartNavigatorButtonState FRightButtonState;
	bool FScrollButtons;
	Graphics::TColor FScrollButtonLeftColor;
	Graphics::TColor FScrollButtonLeftHotColor;
	Graphics::TColor FScrollButtonLeftDownColor;
	Graphics::TColor FScrollButtonRightColor;
	Graphics::TColor FScrollButtonRightHotColor;
	Graphics::TColor FScrollButtonRightDownColor;
	Graphics::TPicture* FScrollButtonLeft;
	Graphics::TPicture* FScrollButtonLeftHot;
	Graphics::TPicture* FScrollButtonLeftDown;
	Graphics::TPicture* FScrollButtonRight;
	Graphics::TPicture* FScrollButtonRightHot;
	Graphics::TPicture* FScrollButtonRightDown;
	int FScrollButtonsSize;
	int FScrollDelta;
	int FSize;
	bool FVisible;
	int FScrollStep;
	int __fastcall GetBottomSize(void);
	void __fastcall SetAlphaBlend(const bool Value);
	void __fastcall SetAlphaBlendValue(const Byte Value);
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetColorTo(const Graphics::TColor Value);
	void __fastcall SetGradientDirection(const TChartGradientDirection Value);
	void __fastcall SetGradientSteps(const int Value);
	void __fastcall SetScrollButtons(const bool Value);
	void __fastcall SetScrollButtonsSize(const int Value);
	void __fastcall SetSize(const int Value);
	void __fastcall SetVisible(const bool Value);
	void __fastcall SetLeftButtonState(const TChartNavigatorButtonState Value);
	void __fastcall SetRightButtonState(const TChartNavigatorButtonState Value);
	void __fastcall SetScrollButtonLeft(const Graphics::TPicture* Value);
	void __fastcall SetScrollButtonLeftDown(const Graphics::TPicture* Value);
	void __fastcall SetScrollButtonLeftHot(const Graphics::TPicture* Value);
	void __fastcall SetScrollButtonRight(const Graphics::TPicture* Value);
	void __fastcall SetScrollButtonRightDown(const Graphics::TPicture* Value);
	void __fastcall SetScrollButtonRightHot(const Graphics::TPicture* Value);
	void __fastcall SetScrollButtonLeftColor(const Graphics::TColor Value);
	void __fastcall SetScrollButtonLeftDownColor(const Graphics::TColor Value);
	void __fastcall SetScrollButtonLeftHotColor(const Graphics::TColor Value);
	void __fastcall SetScrollButtonRightColor(const Graphics::TColor Value);
	void __fastcall SetScrollButtonRightDownColor(const Graphics::TColor Value);
	void __fastcall SetScrollButtonRightHotColor(const Graphics::TColor Value);
	void __fastcall SetScrollStep(const int Value);
	
protected:
	virtual void __fastcall Changed(void);
	
public:
	__fastcall TChartNavigator(TAdvChart* AOwner);
	__fastcall virtual ~TChartNavigator(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	void __fastcall DrawArrow(Graphics::TCanvas* Canvas, const Types::TRect &R, bool Direction, double ScaleX, double ScaleY);
	__property int BottomSize = {read=GetBottomSize, nodefault};
	__property TChartNavigatorButtonState LeftButtonState = {read=FLeftButtonState, write=SetLeftButtonState, nodefault};
	__property TChartNavigatorButtonState RightButtonState = {read=FRightButtonState, write=SetRightButtonState, nodefault};
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property bool AlphaBlend = {read=FAlphaBlend, write=SetAlphaBlend, default=1};
	__property Byte AlphaBlendValue = {read=FAlphaBlendValue, write=SetAlphaBlendValue, default=128};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=16777215};
	__property Graphics::TColor ColorTo = {read=FColorTo, write=SetColorTo, default=536870911};
	__property TChartGradientDirection GradientDirection = {read=FGradientDirection, write=SetGradientDirection, default=1};
	__property int GradientSteps = {read=FGradientSteps, write=SetGradientSteps, default=100};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Graphics::TPicture* ScrollButtonLeft = {read=FScrollButtonLeft, write=SetScrollButtonLeft};
	__property Graphics::TPicture* ScrollButtonLeftHot = {read=FScrollButtonLeftHot, write=SetScrollButtonLeftHot};
	__property Graphics::TPicture* ScrollButtonLeftDown = {read=FScrollButtonLeftDown, write=SetScrollButtonLeftDown};
	__property Graphics::TPicture* ScrollButtonRight = {read=FScrollButtonRight, write=SetScrollButtonRight};
	__property Graphics::TPicture* ScrollButtonRightHot = {read=FScrollButtonRightHot, write=SetScrollButtonRightHot};
	__property Graphics::TPicture* ScrollButtonRightDown = {read=FScrollButtonRightDown, write=SetScrollButtonRightDown};
	__property Graphics::TColor ScrollButtonLeftColor = {read=FScrollButtonLeftColor, write=SetScrollButtonLeftColor, default=536870911};
	__property Graphics::TColor ScrollButtonLeftHotColor = {read=FScrollButtonLeftHotColor, write=SetScrollButtonLeftHotColor, default=536870911};
	__property Graphics::TColor ScrollButtonLeftDownColor = {read=FScrollButtonLeftDownColor, write=SetScrollButtonLeftDownColor, default=536870911};
	__property Graphics::TColor ScrollButtonRightColor = {read=FScrollButtonRightColor, write=SetScrollButtonRightColor, default=536870911};
	__property Graphics::TColor ScrollButtonRightHotColor = {read=FScrollButtonRightHotColor, write=SetScrollButtonRightHotColor, default=536870911};
	__property Graphics::TColor ScrollButtonRightDownColor = {read=FScrollButtonRightDownColor, write=SetScrollButtonRightDownColor, default=536870911};
	__property bool ScrollButtons = {read=FScrollButtons, write=SetScrollButtons, default=1};
	__property int ScrollButtonsSize = {read=FScrollButtonsSize, write=SetScrollButtonsSize, default=11};
	__property int Size = {read=FSize, write=SetSize, default=20};
	__property bool Visible = {read=FVisible, write=SetVisible, default=0};
	__property int ScrollStep = {read=FScrollStep, write=SetScrollStep, default=1};
};


#pragma option push -b-
enum TChartSeriePointType { cspYPos, cspSerie };
#pragma option pop

struct TSeriePoint
{
	int Point;
	double YValue;
	int Serie;
	double XValueAtCursor;
	double XValueAtTracker;
	double XValueYAxis;
	TChartSeriePointType PointType;
	double SerieValue;
} ;

class DELPHICLASS TChartRange;
class PASCALIMPLEMENTATION TChartRange : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FForceMaxRangeTo;
	int FMaxRangeTo;
	Classes::TNotifyEvent FOnChange;
	TAdvChart* FOwner;
	int FRangeFrom;
	int FRangeTo;
	int FMaximumScrollRange;
	int FMinimumScrollRange;
	System::TDateTime FStartDate;
	void __fastcall SetForceMaxRangeTo(const bool Value);
	void __fastcall SetMaxRangeTo(const int Value);
	void __fastcall SetRangeFrom(const int Value);
	void __fastcall SetRangeTo(const int Value);
	void __fastcall SetMaximumScrollRange(const int Value);
	void __fastcall SetMinimumScrollRange(const int Value);
	void __fastcall SetStartDate(const System::TDateTime Value);
	
protected:
	virtual void __fastcall Changed(void);
	
public:
	__fastcall TChartRange(TAdvChart* AOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property int MaxRangeTo = {read=FMaxRangeTo, write=SetMaxRangeTo, nodefault};
	__property bool ForceMaxRangeTo = {read=FForceMaxRangeTo, write=SetForceMaxRangeTo, nodefault};
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property System::TDateTime StartDate = {read=FStartDate, write=SetStartDate};
	__property int RangeFrom = {read=FRangeFrom, write=SetRangeFrom, default=0};
	__property int RangeTo = {read=FRangeTo, write=SetRangeTo, default=10};
	__property int MinimumScrollRange = {read=FMinimumScrollRange, write=SetMinimumScrollRange, default=0};
	__property int MaximumScrollRange = {read=FMaximumScrollRange, write=SetMaximumScrollRange, default=0};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TChartRange(void) { }
	#pragma option pop
	
};


class DELPHICLASS TChartSeries;
#pragma option push -b-
enum TChartMode { cmInit, cmScaling, cmVerticalScrolling, cmHorizontalScrolling };
#pragma option pop

#pragma option push -b-
enum TChartSeriesDonutMode { dmNormal, dmStacked };
#pragma option pop

#pragma option push -b-
enum TChartSerieValueWidthType { wtPixels, wtPercentage };
#pragma option pop

#pragma option push -b-
enum TChartDrawingMode { dmVertical, dmHorizontal };
#pragma option pop

class DELPHICLASS TChartSerie;
#pragma option push -b-
enum TChartType { ctNone, ctLine, ctArea, ctBar, ctLineBar, ctHistogram, ctLineHistogram, ctCandleStick, ctLineCandleStick, ctOHLC, ctMarkers, ctStackedBar, ctStackedArea, ctStackedPercArea, ctStackedPercBar, ctError, ctArrow, ctScaledArrow, ctBubble, ctScaledBubble, ctPie, ctHalfPie, ctDonut, ctHalfDonut, ctBand, ctSpider, ctHalfSpider, ctVarRadiusPie, ctVarRadiusHalfPie, ctVarRadiusDonut, ctVarRadiusHalfDonut, ctSizedPie, ctSizedHalfPie, ctSizedDonut, ctSizedHalfDonut, ctDigitalLine, ctBoxPlot, ctRenko, ctXYLine, ctXYMarkers, ctGantt };
#pragma option pop

class PASCALIMPLEMENTATION TChartSeries : public Classes::TOwnedCollection 
{
	typedef Classes::TOwnedCollection inherited;
	
public:
	TChartSerie* operator[](int Index) { return Items[Index]; }
	
private:
	TChartMode FMode;
	bool FSerieValueTotals;
	TChartSeriesDonutMode FDonutMode;
	Classes::TNotifyEvent FOnChange;
	TAdvChart* FOwner;
	#pragma pack(push, 1)
	Types::TRect FSeriesRectangle;
	#pragma pack(pop)
	
	int FcntBar;
	int FBarChartSpacing;
	TChartSerieValueWidthType FBarChartSpacingType;
	TChartDrawingMode FChartMode;
	HIDESBASE TChartSerie* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, TChartSerie* Value);
	void __fastcall SetSerieValueTotals(const bool Value);
	void __fastcall SetDonutMode(const TChartSeriesDonutMode Value);
	void __fastcall SetBarChartSpacing(const int Value);
	void __fastcall SetBarChartSpacingType(const TChartSerieValueWidthType Value);
	void __fastcall SetChartMode(const TChartDrawingMode Value);
	Types::TRect __fastcall GetSeriesRectangle();
	
protected:
	HIDESBASE virtual void __fastcall Changed(void);
	void __fastcall SerieChanged(System::TObject* Sender);
	virtual void __fastcall Update(Classes::TCollectionItem* Item);
	
public:
	__fastcall TChartSeries(TAdvChart* AOwner);
	__fastcall virtual ~TChartSeries(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual TMetaClass* __fastcall GetItemClass(void);
	void __fastcall ForceInit(bool Force);
	void __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY, unsigned HRGN);
	void __fastcall DrawXValues(Graphics::TCanvas* Canvas, const Types::TRect &R, bool Top, double ScaleX, double ScaleY);
	void __fastcall DrawYValues(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	void __fastcall DrawMarkers(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	void __fastcall DrawAnnotations(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	void __fastcall DrawPieLegends(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	void __fastcall DrawChartValues(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	HIDESBASE TChartSerie* __fastcall Add(void);
	HIDESBASE TChartSerie* __fastcall Insert(int index);
	__property TChartSerie* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
	__property TChartMode Mode = {read=FMode, write=FMode, nodefault};
	__property Types::TRect SeriesRectangle = {read=GetSeriesRectangle, write=FSeriesRectangle};
	virtual void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	virtual void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section, bool AutoCreateSeries = false);
	int __fastcall GetCountChartType(TChartType ChartType);
	int __fastcall GetCountGroupedChartType(TChartType ChartType);
	int __fastcall GetPreviousChartIndex(TChartType ChartType, int Index, int GroupIndex);
	bool __fastcall IsHorizontal(void);
	
__published:
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property bool SerieValueTotals = {read=FSerieValueTotals, write=SetSerieValueTotals, default=0};
	__property TChartSeriesDonutMode DonutMode = {read=FDonutMode, write=SetDonutMode, default=0};
	__property TChartDrawingMode ChartMode = {read=FChartMode, write=SetChartMode, default=0};
	__property int BarChartSpacing = {read=FBarChartSpacing, write=SetBarChartSpacing, default=20};
	__property TChartSerieValueWidthType BarChartSpacingType = {read=FBarChartSpacingType, write=SetBarChartSpacingType, default=1};
};


class DELPHICLASS TChartTitle;
class PASCALIMPLEMENTATION TChartTitle : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Classes::TAlignment FAlignment;
	Graphics::TColor FBorderColor;
	int FBorderWidth;
	Graphics::TColor FColor;
	Graphics::TColor FColorTo;
	int FGradientSteps;
	TChartGradientDirection FGradientDirection;
	Graphics::TFont* FFont;
	Classes::TNotifyEvent FOnChange;
	TAdvChart* FOwner;
	TTitlePosition FPosition;
	int FSize;
	AnsiString FText;
	int __fastcall GetBottomSize(void);
	int __fastcall GetTopSize(void);
	void __fastcall SetAlignment(const Classes::TAlignment Value);
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetFont(const Graphics::TFont* Value);
	void __fastcall SetPosition(const TTitlePosition Value);
	void __fastcall SetSize(const int Value);
	void __fastcall SetText(const AnsiString Value);
	void __fastcall SetBorderColor(const Graphics::TColor Value);
	void __fastcall SetBorderWidth(const int Value);
	void __fastcall SetColorTo(const Graphics::TColor Value);
	void __fastcall SetGradientDirection(const TChartGradientDirection Value);
	void __fastcall SetGradientSteps(const int Value);
	
protected:
	void __fastcall FontChanged(System::TObject* Sender);
	virtual void __fastcall Changed(void);
	
public:
	__fastcall TChartTitle(TAdvChart* AOwner);
	__fastcall virtual ~TChartTitle(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Draw(Graphics::TCanvas* Canvas, bool Top, const Types::TRect &R, double ScaleX, double ScaleY);
	__property int TopSize = {read=GetTopSize, nodefault};
	__property int BottomSize = {read=GetBottomSize, nodefault};
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property Classes::TAlignment Alignment = {read=FAlignment, write=SetAlignment, default=0};
	__property Graphics::TColor BorderColor = {read=FBorderColor, write=SetBorderColor, default=536870911};
	__property int BorderWidth = {read=FBorderWidth, write=SetBorderWidth, default=0};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=536870911};
	__property Graphics::TColor ColorTo = {read=FColorTo, write=SetColorTo, default=536870911};
	__property int GradientSteps = {read=FGradientSteps, write=SetGradientSteps, default=100};
	__property TChartGradientDirection GradientDirection = {read=FGradientDirection, write=SetGradientDirection, default=0};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property TTitlePosition Position = {read=FPosition, write=SetPosition, default=3};
	__property int Size = {read=FSize, write=SetSize, default=20};
	__property AnsiString Text = {read=FText, write=SetText};
};


class DELPHICLASS TChartXAxis;
#pragma option push -b-
enum TChartUnitType { utNumber, utDay, utMonth, utYear, utWeek, utHour, utMinute, utSecond, utMilliSecond };
#pragma option pop

class PASCALIMPLEMENTATION TChartXAxis : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Classes::TAlignment FAlignment;
	Graphics::TColor FColor;
	Graphics::TColor FColorTo;
	Graphics::TFont* FFont;
	TChartGradientDirection FGradientDirection;
	int FGradientSteps;
	int FLineWidth;
	bool FLine;
	Graphics::TColor FLineColor;
	Classes::TNotifyEvent FOnChange;
	TAdvChart* FOwner;
	TChartXAxisPosition FPosition;
	int FSize;
	AnsiString FText;
	TChartUnitType FUnitType;
	int FOffset3D;
	bool FDarken3D;
	bool FEnable3D;
	bool FAutoSize;
	int __fastcall GetBottomSize(void);
	int __fastcall GetTopSize(void);
	void __fastcall SetAlignment(const Classes::TAlignment Value);
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetColorTo(const Graphics::TColor Value);
	void __fastcall SetFont(const Graphics::TFont* Value);
	void __fastcall SetGradientDirection(const TChartGradientDirection Value);
	void __fastcall SetGradientSteps(const int Value);
	void __fastcall SetLine(const bool Value);
	void __fastcall SetLineColor(const Graphics::TColor Value);
	void __fastcall SetLineWidth(const int Value);
	void __fastcall SetPosition(const TChartXAxisPosition Value);
	void __fastcall SetSize(const int Value);
	void __fastcall SetText(const AnsiString Value);
	void __fastcall SetUnitType(const TChartUnitType Value);
	int __fastcall GetBottomLineSize(void);
	int __fastcall GetTopLineSize(void);
	void __fastcall SetDarken3D(const bool Value);
	void __fastcall SetEnable3D(const bool Value);
	void __fastcall SetOffset3D(const int Value);
	void __fastcall SetAutoSize(const bool Value);
	
protected:
	void __fastcall FontChanged(System::TObject* Sender);
	virtual void __fastcall Changed(void);
	
public:
	__fastcall TChartXAxis(TAdvChart* AOwner);
	__fastcall virtual ~TChartXAxis(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &R, bool Top, double ScaleX, double ScaleY, bool Horizontal);
	__property int TopSize = {read=GetTopSize, nodefault};
	__property int BottomSize = {read=GetBottomSize, nodefault};
	__property int TopLineSize = {read=GetTopLineSize, nodefault};
	__property int BottomLineSize = {read=GetBottomLineSize, nodefault};
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property bool AutoSize = {read=FAutoSize, write=SetAutoSize, default=0};
	__property Classes::TAlignment Alignment = {read=FAlignment, write=SetAlignment, default=2};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=536870911};
	__property Graphics::TColor ColorTo = {read=FColorTo, write=SetColorTo, default=536870911};
	__property TChartGradientDirection GradientDirection = {read=FGradientDirection, write=SetGradientDirection, default=0};
	__property int GradientSteps = {read=FGradientSteps, write=SetGradientSteps, default=100};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property bool Line = {read=FLine, write=SetLine, default=1};
	__property Graphics::TColor LineColor = {read=FLineColor, write=SetLineColor, default=0};
	__property int LineWidth = {read=FLineWidth, write=SetLineWidth, default=1};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property TChartXAxisPosition Position = {read=FPosition, write=SetPosition, default=0};
	__property int Size = {read=FSize, write=SetSize, default=30};
	__property AnsiString Text = {read=FText, write=SetText};
	__property TChartUnitType UnitType = {read=FUnitType, write=SetUnitType, default=0};
	__property bool Enable3D = {read=FEnable3D, write=SetEnable3D, default=0};
	__property bool Darken3D = {read=FDarken3D, write=SetDarken3D, default=1};
	__property int Offset3D = {read=FOffset3D, write=SetOffset3D, default=20};
};


class DELPHICLASS TChartXGrid;
class PASCALIMPLEMENTATION TChartXGrid : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FMinorDistance;
	int FMajorDistance;
	Graphics::TColor FMinorLineColor;
	Graphics::TColor FMajorLineColor;
	Graphics::TPenStyle FMinorLineStyle;
	Graphics::TPenStyle FMajorLineStyle;
	int FMinorLineWidth;
	int FMajorLineWidth;
	Graphics::TFont* FMinorFont;
	Graphics::TFont* FMajorFont;
	Classes::TNotifyEvent FOnChange;
	bool FOnTop;
	TAdvChart* FOwner;
	bool FVisible;
	bool FAutoUnits;
	void __fastcall SetMajorDistance(const int Value);
	void __fastcall SetMajorFont(const Graphics::TFont* Value);
	void __fastcall SetMajorLineColor(const Graphics::TColor Value);
	void __fastcall SetMajorLineStyle(const Graphics::TPenStyle Value);
	void __fastcall SetMajorLineWidth(const int Value);
	void __fastcall SetMinorDistance(const int Value);
	void __fastcall SetMinorFont(const Graphics::TFont* Value);
	void __fastcall SetMinorLineColor(const Graphics::TColor Value);
	void __fastcall SetMinorLineStyle(const Graphics::TPenStyle Value);
	void __fastcall SetMinorLineWidth(const int Value);
	void __fastcall SetOnTop(const bool Value);
	void __fastcall SetVisible(const bool Value);
	void __fastcall SetAutoUnits(const bool Value);
	
protected:
	void __fastcall FontChanged(System::TObject* Sender);
	virtual void __fastcall Changed(void);
	
public:
	__fastcall TChartXGrid(TAdvChart* AOwner);
	__fastcall virtual ~TChartXGrid(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property bool AutoUnits = {read=FAutoUnits, write=SetAutoUnits, default=1};
	__property int MinorDistance = {read=FMinorDistance, write=SetMinorDistance, default=10};
	__property int MajorDistance = {read=FMajorDistance, write=SetMajorDistance, default=20};
	__property Graphics::TColor MinorLineColor = {read=FMinorLineColor, write=SetMinorLineColor, default=0};
	__property Graphics::TColor MajorLineColor = {read=FMajorLineColor, write=SetMajorLineColor, default=0};
	__property Graphics::TPenStyle MinorLineStyle = {read=FMinorLineStyle, write=SetMinorLineStyle, default=0};
	__property Graphics::TPenStyle MajorLineStyle = {read=FMajorLineStyle, write=SetMajorLineStyle, default=2};
	__property int MinorLineWidth = {read=FMinorLineWidth, write=SetMinorLineWidth, default=1};
	__property int MajorLineWidth = {read=FMajorLineWidth, write=SetMajorLineWidth, default=1};
	__property Graphics::TFont* MajorFont = {read=FMajorFont, write=SetMajorFont};
	__property Graphics::TFont* MinorFont = {read=FMinorFont, write=SetMinorFont};
	__property bool OnTop = {read=FOnTop, write=SetOnTop, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property bool Visible = {read=FVisible, write=SetVisible, default=0};
};


class DELPHICLASS TChartYAxis;
class PASCALIMPLEMENTATION TChartYAxis : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FLeftSize;
	int FRightSize;
	Classes::TAlignment FAlignment;
	bool FAutoUnits;
	Graphics::TColor FColor;
	Graphics::TColor FColorTo;
	TChartGradientDirection FGradientDirection;
	int FGradientSteps;
	Graphics::TFont* FFont;
	int FLineWidth;
	bool FLine;
	Graphics::TColor FLineColor;
	Classes::TNotifyEvent FOnChange;
	TAdvChart* FOwner;
	TChartYAxisPosition FPosition;
	int FSize;
	AnsiString FText;
	int FOffset3D;
	bool FDarken3D;
	bool FEnable3D;
	bool FAutoSize;
	int __fastcall GetLeftSize(void);
	int __fastcall GetRightSize(void);
	void __fastcall SetAlignment(const Classes::TAlignment Value);
	void __fastcall SetAutoUnits(const bool Value);
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetColorTo(const Graphics::TColor Value);
	void __fastcall SetFont(const Graphics::TFont* Value);
	void __fastcall SetGradientDirection(const TChartGradientDirection Value);
	void __fastcall SetGradientSteps(const int Value);
	void __fastcall SetLine(const bool Value);
	void __fastcall SetLineColor(const Graphics::TColor Value);
	void __fastcall SetLineWidth(const int Value);
	void __fastcall SetPosition(const TChartYAxisPosition Value);
	void __fastcall SetSize(const int Value);
	void __fastcall SetText(const AnsiString Value);
	int __fastcall GetLeftLineSize(void);
	int __fastcall GetRightLineSize(void);
	void __fastcall SetDarken3D(const bool Value);
	void __fastcall SetEnable3D(const bool Value);
	void __fastcall SetOffset3D(const int Value);
	void __fastcall SetAutoSize(const bool Value);
	void __fastcall SetLeftSize(const int Value);
	void __fastcall SetRightSize(const int Value);
	
protected:
	void __fastcall FontChanged(System::TObject* Sender);
	virtual void __fastcall Changed(void);
	
public:
	__fastcall TChartYAxis(TAdvChart* AOwner);
	__fastcall virtual ~TChartYAxis(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property int LeftSize = {read=GetLeftSize, write=SetLeftSize, nodefault};
	__property int LeftLineSize = {read=GetLeftLineSize, nodefault};
	__property int RightSize = {read=GetRightSize, write=SetRightSize, nodefault};
	__property int RightLineSize = {read=GetRightLineSize, nodefault};
	void __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &R, bool Left, double ScaleX, double ScaleY, bool Horizontal);
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property bool AutoSize = {read=FAutoSize, write=SetAutoSize, default=0};
	__property Classes::TAlignment Alignment = {read=FAlignment, write=SetAlignment, default=2};
	__property bool AutoUnits = {read=FAutoUnits, write=SetAutoUnits, default=1};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=536870911};
	__property Graphics::TColor ColorTo = {read=FColorTo, write=SetColorTo, default=536870911};
	__property TChartGradientDirection GradientDirection = {read=FGradientDirection, write=SetGradientDirection, default=0};
	__property int GradientSteps = {read=FGradientSteps, write=SetGradientSteps, default=100};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property bool Line = {read=FLine, write=SetLine, default=1};
	__property Graphics::TColor LineColor = {read=FLineColor, write=SetLineColor, default=0};
	__property int LineWidth = {read=FLineWidth, write=SetLineWidth, default=1};
	__property TChartYAxisPosition Position = {read=FPosition, write=SetPosition, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property int Size = {read=FSize, write=SetSize, default=30};
	__property AnsiString Text = {read=FText, write=SetText};
	__property bool Enable3D = {read=FEnable3D, write=SetEnable3D, default=0};
	__property bool Darken3D = {read=FDarken3D, write=SetDarken3D, default=1};
	__property int Offset3D = {read=FOffset3D, write=SetOffset3D, default=20};
};


class DELPHICLASS TChartYGrid;
class PASCALIMPLEMENTATION TChartYGrid : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FAutoUnits;
	Graphics::TColor FBorderColor;
	double FMinorDistance;
	double FMajorDistance;
	Graphics::TColor FMinorLineColor;
	Graphics::TColor FMajorLineColor;
	Graphics::TPenStyle FMinorLineStyle;
	Graphics::TPenStyle FMajorLineStyle;
	int FMinorLineWidth;
	int FMajorLineWidth;
	Classes::TNotifyEvent FOnChange;
	bool FOnTop;
	TAdvChart* FOwner;
	bool FVisible;
	int FSerieIndex;
	bool FShowBorder;
	void __fastcall SetAutoUnits(const bool Value);
	void __fastcall SetBorderColor(const Graphics::TColor Value);
	void __fastcall SetMajorDistance(const double Value);
	void __fastcall SetMajorLineColor(const Graphics::TColor Value);
	void __fastcall SetMajorLineStyle(const Graphics::TPenStyle Value);
	void __fastcall SetMajorLineWidth(const int Value);
	void __fastcall SetMinorDistance(const double Value);
	void __fastcall SetMinorLineColor(const Graphics::TColor Value);
	void __fastcall SetMinorLineStyle(const Graphics::TPenStyle Value);
	void __fastcall SetMinorLineWidth(const int Value);
	void __fastcall SetOnTop(const bool Value);
	void __fastcall SetSerieIndex(const int Value);
	void __fastcall SetShowBorder(const bool Value);
	void __fastcall SetVisible(const bool Value);
	
protected:
	virtual void __fastcall Changed(void);
	
public:
	__fastcall virtual TChartYGrid(TAdvChart* AOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property bool AutoUnits = {read=FAutoUnits, write=SetAutoUnits, default=1};
	__property Graphics::TColor BorderColor = {read=FBorderColor, write=SetBorderColor, default=536870911};
	__property double MinorDistance = {read=FMinorDistance, write=SetMinorDistance};
	__property double MajorDistance = {read=FMajorDistance, write=SetMajorDistance};
	__property Graphics::TColor MinorLineColor = {read=FMinorLineColor, write=SetMinorLineColor, default=8421504};
	__property Graphics::TColor MajorLineColor = {read=FMajorLineColor, write=SetMajorLineColor, default=12632256};
	__property Graphics::TPenStyle MinorLineStyle = {read=FMinorLineStyle, write=SetMinorLineStyle, default=2};
	__property Graphics::TPenStyle MajorLineStyle = {read=FMajorLineStyle, write=SetMajorLineStyle, default=0};
	__property int MinorLineWidth = {read=FMinorLineWidth, write=SetMinorLineWidth, default=1};
	__property int MajorLineWidth = {read=FMajorLineWidth, write=SetMajorLineWidth, default=1};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property bool OnTop = {read=FOnTop, write=SetOnTop, default=0};
	__property bool Visible = {read=FVisible, write=SetVisible, default=0};
	__property int SerieIndex = {read=FSerieIndex, write=SetSerieIndex, default=0};
	__property bool ShowBorder = {read=FShowBorder, write=SetShowBorder, default=0};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TChartYGrid(void) { }
	#pragma option pop
	
};


typedef void __fastcall (__closure *TChartDrawEvent)(System::TObject* Sender, const Types::TRect &ARect, Graphics::TCanvas* ACanvas);

typedef void __fastcall (__closure *TChartPaneRectangle)(TAdvChart* Chart, Types::TRect &PaneRect);

typedef void __fastcall (__closure *TChartSerieXAxisCustomGroupEvent)(System::TObject* Sender, int Pane, int Serie, int GroupIndex, Graphics::TCanvas* Canvas, const Types::TRect &R, bool &DrawText);

struct TPointCheck;
struct TXAxisRangeValue;
struct TYAxisRangeValue;
class PASCALIMPLEMENTATION TAdvChart : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TChartAxisMode FAxisMode;
	bool FGDIPDrawing;
	TChartBackground* FBackground;
	TChartBands* FBands;
	TChartCrossHair* FCrossHair;
	bool FForceInitYScale;
	TChartMargin* FMargin;
	TChartNavigator* FNavigator;
	TChartLegend* FLegend;
	Classes::TNotifyEvent FOnChange;
	Classes::TPersistent* FOwner;
	TSeriePoint FPointValue;
	TChartRange* FRange;
	double FSerieMinValue;
	double FSerieMaxValue;
	TChartSeries* FSeries;
	TChartTitle* FTitle;
	TChartXAxis* FXAxis;
	TChartXGrid* FXGrid;
	double FXScale;
	TChartYAxis* FYAxis;
	TChartYGrid* FYGrid;
	int FUpdateCount;
	TChartDrawEvent FOnDrawBackGround;
	TChartDrawEvent FOnDrawTitle;
	TChartDrawEvent FOnDrawXGrid;
	TChartDrawEvent FOnDrawNavigator;
	TChartDrawEvent FOnDrawLegend;
	TChartDrawEvent FOnDrawXValues;
	TChartDrawEvent FOnDrawYValues;
	TChartDrawEvent FOnDrawYGrid;
	TChartDrawEvent FOnDrawSeries;
	TChartDrawEvent FOnDrawXAxis;
	TChartDrawEvent FOnDrawYAxis;
	TChartPaneRectangle FGetPaneRectangle;
	TChartSerieXAxisCustomGroupEvent FOnSerieXAxisGroup;
	bool FXScaleOffset;
	void __fastcall SetXScale(const double Value);
	void __fastcall SetAxisMode(const TChartAxisMode Value);
	void __fastcall SetXScaleOffset(const bool Value);
	
protected:
	void __fastcall RangeChanged(System::TObject* Sender);
	void __fastcall XAxisChanged(System::TObject* Sender);
	void __fastcall YAxisChanged(System::TObject* Sender);
	void __fastcall XGridChanged(System::TObject* Sender);
	void __fastcall YGridChanged(System::TObject* Sender);
	void __fastcall BackgroundChanged(System::TObject* Sender);
	void __fastcall SeriesChanged(System::TObject* Sender);
	void __fastcall MarginChanged(System::TObject* Sender);
	void __fastcall BandsChanged(System::TObject* Sender);
	void __fastcall LegendChanged(System::TObject* Sender);
	void __fastcall TitleChanged(System::TObject* Sender);
	void __fastcall CrossHairChanged(System::TObject* Sender);
	void __fastcall NavigatorChanged(System::TObject* Sender);
	virtual void __fastcall Changed(void);
	virtual TChartLegend* __fastcall CreateLegend(void);
	virtual TChartBackground* __fastcall CreateBackground(void);
	virtual TChartSeries* __fastcall CreateSeries(void);
	void __fastcall SaveChart(Graphics::TCanvas* c, const Types::TRect &R);
	virtual void __fastcall FindInterSection(const Types::TPoint &p1, const Types::TPoint &p2, const Types::TPoint &p3, const Types::TPoint &p4, TPointCheck &ptchk);
	int __fastcall GetMax3DOffset(void);
	Types::TRect __fastcall GetXAxisTopRect(const Types::TRect &R);
	Types::TRect __fastcall GetXAxisBottomRect(const Types::TRect &R);
	Types::TRect __fastcall GetYAxisRect(const Types::TRect &R);
	
public:
	double __fastcall GetXScaleStart(void);
	void __fastcall SaveToImage(AnsiString Filename, int ImageWidth, int ImageHeigth);
	__fastcall TAdvChart(Classes::TPersistent* AOwner);
	__fastcall virtual ~TAdvChart(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall CalculateYScale(const Types::TRect &R, double ScaleX, double ScaleY);
	void __fastcall DrawZeroLine(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	void __fastcall Initialize(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	void __fastcall SetMinMax(void);
	void __fastcall InitializeChart(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	Types::TRect __fastcall SeriesRectangle(const Types::TRect &R, double ScaleX, double ScaleY);
	virtual Types::TRect __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY, bool Initialize = false);
	virtual void __fastcall DrawXAxis(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	__property bool ForceInitYScale = {read=FForceInitYScale, write=FForceInitYScale, nodefault};
	__property Classes::TPersistent* Owner = {read=FOwner};
	__property TSeriePoint PointValue = {read=FPointValue, write=FPointValue};
	__property double XScale = {read=FXScale, write=SetXScale};
	__property bool GDIPDrawing = {read=FGDIPDrawing, write=FGDIPDrawing, nodefault};
	void __fastcall BeginUpdate(void);
	void __fastcall EndUpdate(Graphics::TCanvas* Canvas, const Types::TRect &R);
	void __fastcall ResetUpdate(void);
	TChartSeriePoint __fastcall XYToSeriePoint(int X, int Y);
	TChartSerie* __fastcall GetLegendItemAtXY(int X, int Y);
	TChartSeriePoint __fastcall GetPieLegendItemAtXY(int X, int Y);
	TChartSeriePoint __fastcall GetSerieIndexAtXY(int X, int Y);
	TXAxisRangeValue __fastcall GetXAxisValue(int X, int Y, const Types::TRect &R);
	TYAxisRangeValue __fastcall GetYAxisValue(int X, int Y, const Types::TRect &R);
	int __fastcall GetTotalYAxisLeftSize(void);
	int __fastcall GetTotalYAxisRightSize(void);
	int __fastcall GetTotalYAxisSize(const Types::TRect &R, bool Right);
	int __fastcall GetTotalXAxisSize(const Types::TRect &R, bool Bottom);
	__property TChartPaneRectangle GetPaneRectangle = {read=FGetPaneRectangle, write=FGetPaneRectangle};
	
__published:
	__property TChartAxisMode AxisMode = {read=FAxisMode, write=SetAxisMode, nodefault};
	__property TChartBackground* BackGround = {read=FBackground, write=FBackground};
	__property TChartBands* Bands = {read=FBands, write=FBands};
	__property TChartCrossHair* CrossHair = {read=FCrossHair, write=FCrossHair};
	__property TChartMargin* Margin = {read=FMargin, write=FMargin};
	__property TChartLegend* Legend = {read=FLegend, write=FLegend};
	__property TChartNavigator* Navigator = {read=FNavigator, write=FNavigator};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property TChartRange* Range = {read=FRange, write=FRange};
	__property TChartSeries* Series = {read=FSeries, write=FSeries};
	__property TChartTitle* Title = {read=FTitle, write=FTitle};
	__property TChartXAxis* XAxis = {read=FXAxis, write=FXAxis};
	__property TChartXGrid* XGrid = {read=FXGrid, write=FXGrid};
	__property TChartYAxis* YAxis = {read=FYAxis, write=FYAxis};
	__property TChartYGrid* YGrid = {read=FYGrid, write=FYGrid};
	__property TChartDrawEvent OnDrawBackGround = {read=FOnDrawBackGround, write=FOnDrawBackGround};
	__property TChartDrawEvent OnDrawXAxis = {read=FOnDrawXAxis, write=FOnDrawXAxis};
	__property TChartDrawEvent OnDrawXGrid = {read=FOnDrawXGrid, write=FOnDrawXGrid};
	__property TChartDrawEvent OnDrawYAxis = {read=FOnDrawYAxis, write=FOnDrawYAxis};
	__property TChartDrawEvent OnDrawYGrid = {read=FOnDrawYGrid, write=FOnDrawYGrid};
	__property TChartDrawEvent OnDrawLegend = {read=FOnDrawLegend, write=FOnDrawLegend};
	__property TChartDrawEvent OnDrawSeries = {read=FOnDrawSeries, write=FOnDrawSeries};
	__property TChartDrawEvent OnDrawTitle = {read=FOnDrawTitle, write=FOnDrawTitle};
	__property TChartDrawEvent OnDrawYValues = {read=FOnDrawYValues, write=FOnDrawYValues};
	__property TChartDrawEvent OnDrawXValues = {read=FOnDrawXValues, write=FOnDrawXValues};
	__property TChartDrawEvent OnDrawNavigator = {read=FOnDrawNavigator, write=FOnDrawNavigator};
	__property TChartSerieXAxisCustomGroupEvent OnSerieXAxisGroup = {read=FOnSerieXAxisGroup, write=FOnSerieXAxisGroup};
	__property bool XScaleOffset = {read=FXScaleOffset, write=SetXScaleOffset, default=1};
};


class PASCALIMPLEMENTATION TChartLegend : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Graphics::TColor FBorderColor;
	int FBorderWidth;
	int FBorderRounding;
	TChartBackGroundPosition FBackgroundPosition;
	Graphics::TColor FColor;
	Graphics::TColor FColorTo;
	Graphics::TFont* FFont;
	int FGradientSteps;
	TChartGradientDirection FGradientDirection;
	int FLeft;
	TAdvChart* FOwner;
	Classes::TNotifyEvent FOnChange;
	Graphics::TPicture* FPicture;
	int FRectangleSize;
	int FRectangleSpacing;
	int FTop;
	bool FVisible;
	bool FDrawBkg;
	TChartLegendAlignment FAlignment;
	void __fastcall SetBorderColor(const Graphics::TColor Value);
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetColorTo(const Graphics::TColor Value);
	void __fastcall SetFont(const Graphics::TFont* Value);
	void __fastcall SetGradientDirection(const TChartGradientDirection Value);
	void __fastcall SetGradientSteps(const int Value);
	void __fastcall SetLeft(const int Value);
	void __fastcall SetRectangleSize(const int Value);
	void __fastcall SetRectangleSpacing(const int Value);
	void __fastcall SetTop(const int Value);
	void __fastcall SetVisible(const bool Value);
	void __fastcall SetBorderWidth(const int Value);
	void __fastcall SetBorderRounding(const int Value);
	void __fastcall SetPicture(const Graphics::TPicture* Value);
	void __fastcall SetBackGroundPosition(const TChartBackGroundPosition Value);
	void __fastcall SetAlignment(const TChartLegendAlignment Value);
	
protected:
	virtual void __fastcall Changed(void);
	void __fastcall FontChanged(System::TObject* Sender);
	__property bool DrawBkg = {read=FDrawBkg, write=FDrawBkg, nodefault};
	
public:
	__fastcall virtual TChartLegend(TAdvChart* AOwner);
	__fastcall virtual ~TChartLegend(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	virtual void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	virtual void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	Types::TRect __fastcall GetRectangle();
	
__published:
	__property TChartLegendAlignment Alignment = {read=FAlignment, write=SetAlignment, default=9};
	__property Graphics::TColor BorderColor = {read=FBorderColor, write=SetBorderColor, default=0};
	__property int BorderWidth = {read=FBorderWidth, write=SetBorderWidth, default=1};
	__property int BorderRounding = {read=FBorderRounding, write=SetBorderRounding, default=0};
	__property TChartBackGroundPosition BackGroundPosition = {read=FBackgroundPosition, write=SetBackGroundPosition, default=0};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=16777215};
	__property Graphics::TColor ColorTo = {read=FColorTo, write=SetColorTo, default=536870911};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property TChartGradientDirection GradientDirection = {read=FGradientDirection, write=SetGradientDirection, default=0};
	__property int GradientSteps = {read=FGradientSteps, write=SetGradientSteps, default=100};
	__property int Left = {read=FLeft, write=SetLeft, default=0};
	__property int Top = {read=FTop, write=SetTop, default=0};
	__property Graphics::TPicture* Picture = {read=FPicture, write=SetPicture};
	__property int RectangleSize = {read=FRectangleSize, write=SetRectangleSize, default=10};
	__property int RectangleSpacing = {read=FRectangleSpacing, write=SetRectangleSpacing, default=5};
	__property bool Visible = {read=FVisible, write=SetVisible, default=1};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};


#pragma option push -b-
enum TChartPointValueType { cpvSingle, cpvMulti };
#pragma option pop

struct TChartPoint
{
	double SingleValue;
	double SingleXValue;
	double SecondValue;
	double OpenValue;
	double LowValue;
	double HighValue;
	double MedValue;
	double CloseValue;
	bool Defined;
	int PixelValue1;
	int PixelValue2;
	Graphics::TColor Color;
	Graphics::TColor ColorTo;
	Graphics::TColor TextColor;
	Graphics::TColor BorderColor;
	TChartGradientDirection GradientDirection;
	System::TDateTime TimeStamp;
	System::TDateTime TimeXStamp;
	TChartPointValueType ValueType;
	AnsiString LegendValue;
	int Tag;
} ;

#pragma option push -b-
enum TChartMarkerType { mNone, mCircle, mSquare, mDiamond, mTriangle, mPicture, mCustom };
#pragma option pop

typedef void __fastcall (__closure *TChartMarkerDrawEvent)(System::TObject* Sender, TChartSerie* Serie, Graphics::TCanvas* Canvas, int X, int Y, int Point, const TChartPoint &value);

#pragma option push -b-
enum TChartSerieXAxisGroupLineType { xgltVertical, xgltVerticalLine, xgltWrap, xgltCustom };
#pragma option pop

class DELPHICLASS TChartSerieXAxisGroup;
class PASCALIMPLEMENTATION TChartSerieXAxisGroup : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	Graphics::TColor FLineColor;
	int FStartIndex;
	TChartSerieXAxisGroupLineType FLineType;
	int FEndIndex;
	Graphics::TFont* FFont;
	AnsiString FCaption;
	bool FVisible;
	int FLevel;
	int FSpacing;
	void __fastcall SetCaption(const AnsiString Value);
	void __fastcall SetEndIndex(const int Value);
	void __fastcall SetFont(const Graphics::TFont* Value);
	void __fastcall SetLineColor(const Graphics::TColor Value);
	void __fastcall SetLineType(const TChartSerieXAxisGroupLineType Value);
	void __fastcall SetStartIndex(const int Value);
	void __fastcall SetVisible(const bool Value);
	void __fastcall SetLevel(const int Value);
	void __fastcall SetSpacing(const int Value);
	
protected:
	void __fastcall FontChanged(System::TObject* Sender);
	HIDESBASE void __fastcall Changed(void);
	
public:
	__fastcall virtual TChartSerieXAxisGroup(Classes::TCollection* Collection);
	__fastcall virtual ~TChartSerieXAxisGroup(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property AnsiString Caption = {read=FCaption, write=SetCaption};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property int StartIndex = {read=FStartIndex, write=SetStartIndex, default=0};
	__property int EndIndex = {read=FEndIndex, write=SetEndIndex, default=3};
	__property Graphics::TColor LineColor = {read=FLineColor, write=SetLineColor, default=0};
	__property TChartSerieXAxisGroupLineType LineType = {read=FLineType, write=SetLineType, default=0};
	__property bool Visible = {read=FVisible, write=SetVisible, default=1};
	__property int Level = {read=FLevel, write=SetLevel, default=0};
	__property int Spacing = {read=FSpacing, write=SetSpacing, default=3};
};


class DELPHICLASS TChartSerieXAxisGroups;
class PASCALIMPLEMENTATION TChartSerieXAxisGroups : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
public:
	TChartSerieXAxisGroup* operator[](int Index) { return Items[Index]; }
	
private:
	TChartSerie* FOwner;
	HIDESBASE TChartSerieXAxisGroup* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, const TChartSerieXAxisGroup* Value);
	
public:
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	__fastcall TChartSerieXAxisGroups(TChartSerie* AOwner);
	HIDESBASE TChartSerieXAxisGroup* __fastcall Add(void);
	HIDESBASE TChartSerieXAxisGroup* __fastcall Insert(int Index);
	__property TChartSerieXAxisGroup* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TChartSerieXAxisGroups(void) { }
	#pragma option pop
	
};


class DELPHICLASS TChartMarker;
class PASCALIMPLEMENTATION TChartMarker : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TChartMarkerType FMarkerType;
	int FMarkerSize;
	Graphics::TColor FMarkerColor;
	Graphics::TColor FMarkerLineColor;
	int FMarkerLineWidth;
	Graphics::TPicture* FMarkerPicture;
	Graphics::TColor FSelectedColor;
	Graphics::TColor FSelectedLineColor;
	int FSelectedLineWidth;
	int FSelectedIndex;
	int FSelectedSize;
	int FDisplayIndex;
	Classes::TNotifyEvent FOnChange;
	bool FIncreaseDecreaseMode;
	void __fastcall SetMarkerColor(const Graphics::TColor Value);
	void __fastcall SetMarkerLineColor(const Graphics::TColor Value);
	void __fastcall SetMarkerLineWidth(const int Value);
	void __fastcall SetMarkerSize(const int Value);
	void __fastcall SetMarkerType(const TChartMarkerType Value);
	void __fastcall SetMarkerPicture(const Graphics::TPicture* Value);
	void __fastcall SetSelectedColor(const Graphics::TColor Value);
	void __fastcall SetSelectedLineColor(const Graphics::TColor Value);
	void __fastcall SetSelectedLineWidth(const int Value);
	void __fastcall SetSelectedSize(const int Value);
	void __fastcall SetSelectedIndex(const int Value);
	void __fastcall SetIncreaseDecreaseMode(const bool Value);
	
protected:
	virtual void __fastcall Changed(void);
	
public:
	__fastcall virtual TChartMarker(void);
	__fastcall virtual ~TChartMarker(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	virtual void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	__property int SelectedIndex = {read=FSelectedIndex, write=SetSelectedIndex, default=-1};
	__property int DisplayIndex = {read=FDisplayIndex, write=FDisplayIndex, nodefault};
	
__published:
	__property TChartMarkerType MarkerType = {read=FMarkerType, write=SetMarkerType, default=0};
	__property Graphics::TColor MarkerColor = {read=FMarkerColor, write=SetMarkerColor, default=16777215};
	__property int MarkerSize = {read=FMarkerSize, write=SetMarkerSize, default=10};
	__property int MarkerLineWidth = {read=FMarkerLineWidth, write=SetMarkerLineWidth, default=1};
	__property Graphics::TColor MarkerLineColor = {read=FMarkerLineColor, write=SetMarkerLineColor, default=0};
	__property Graphics::TPicture* MarkerPicture = {read=FMarkerPicture, write=SetMarkerPicture};
	__property Graphics::TColor SelectedColor = {read=FSelectedColor, write=SetSelectedColor, default=536870911};
	__property Graphics::TColor SelectedLineColor = {read=FSelectedLineColor, write=SetSelectedLineColor, default=536870911};
	__property int SelectedLineWidth = {read=FSelectedLineWidth, write=SetSelectedLineWidth, default=1};
	__property int SelectedSize = {read=FSelectedSize, write=SetSelectedSize, default=12};
	__property bool IncreaseDecreaseMode = {read=FIncreaseDecreaseMode, write=SetIncreaseDecreaseMode, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};


#pragma option push -b-
enum TChartTextPosition { ctLeft, ctRight, ctCenter, ctTop, ctBottom };
#pragma option pop

class DELPHICLASS TChartXYAxisText;
class PASCALIMPLEMENTATION TChartXYAxisText : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FAngle;
	Graphics::TFont* FFont;
	int FOffset;
	Classes::TNotifyEvent FOnChange;
	TChartTextPosition FPosition;
	AnsiString FText;
	void __fastcall SetAngle(const int Value);
	void __fastcall SetFont(const Graphics::TFont* Value);
	void __fastcall SetOffset(const int Value);
	void __fastcall SetPosition(const TChartTextPosition Value);
	void __fastcall SetText(const AnsiString Value);
	
protected:
	virtual void __fastcall Changed(void);
	void __fastcall FontChanged(System::TObject* Sender);
	void __fastcall TextTopChanged(System::TObject* Sender);
	void __fastcall TextBottomChanged(System::TObject* Sender);
	
public:
	__fastcall TChartXYAxisText(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__fastcall virtual ~TChartXYAxisText(void);
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property int Angle = {read=FAngle, write=SetAngle, default=0};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property int Offset = {read=FOffset, write=SetOffset, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property TChartTextPosition Position = {read=FPosition, write=SetPosition, default=0};
	__property AnsiString Text = {read=FText, write=SetText};
};


#pragma option push -b-
enum TChartValueType { cvNone, cvNormal, cvPercentage };
#pragma option pop

class DELPHICLASS TChartSerieYAxis;
class PASCALIMPLEMENTATION TChartSerieYAxis : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Graphics::TFont* FMajorFont;
	double FMajorUnit;
	int FMajorUnitSpacing;
	Graphics::TFont* FMinorFont;
	double FMinorUnit;
	int FMinorUnitSpacing;
	Classes::TNotifyEvent FOnChange;
	TChartYAxisPosition FPosition;
	TChartXYAxisText* FTextLeft;
	TChartXYAxisText* FTextRight;
	Graphics::TColor FTickMarkColor;
	int FTickMarkSize;
	int FTickMarkWidth;
	bool FVisible;
	int FTickMarkSizeMinor;
	bool FMinorUnitVisible;
	bool FMajorUnitVisible;
	bool FAutoUnits;
	void __fastcall SetMajorFont(const Graphics::TFont* Value);
	void __fastcall SetMajorUnit(const double Value);
	void __fastcall SetMajorUnitSpacing(const int Value);
	void __fastcall SetMinorFont(const Graphics::TFont* Value);
	void __fastcall SetMinorUnit(const double Value);
	void __fastcall SetMinorUnitSpacing(const int Value);
	void __fastcall SetPosition(const TChartYAxisPosition Value);
	void __fastcall SetTextLeft(const TChartXYAxisText* Value);
	void __fastcall SetTextRight(const TChartXYAxisText* Value);
	void __fastcall SetTickMarkColor(const Graphics::TColor Value);
	void __fastcall SetTickMarkSize(const int Value);
	void __fastcall SetTickMarkWidth(const int Value);
	void __fastcall SetVisible(const bool Value);
	void __fastcall SetTickMarkSizeMinor(const int Value);
	void __fastcall SetMajorUnitVisible(const bool Value);
	void __fastcall SetMinorUnitVisible(const bool Value);
	void __fastcall SetAutoUnits(const bool Value);
	
protected:
	virtual void __fastcall Changed(void);
	void __fastcall FontChanged(System::TObject* Sender);
	void __fastcall TextLeftChanged(System::TObject* Sender);
	void __fastcall TextRightChanged(System::TObject* Sender);
	
public:
	__fastcall TChartSerieYAxis(void);
	__fastcall virtual ~TChartSerieYAxis(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property bool AutoUnits = {read=FAutoUnits, write=SetAutoUnits, default=1};
	__property Graphics::TFont* MajorFont = {read=FMajorFont, write=SetMajorFont};
	__property double MajorUnit = {read=FMajorUnit, write=SetMajorUnit};
	__property bool MajorUnitVisible = {read=FMajorUnitVisible, write=SetMajorUnitVisible, default=1};
	__property int MajorUnitSpacing = {read=FMajorUnitSpacing, write=SetMajorUnitSpacing, default=2};
	__property Graphics::TFont* MinorFont = {read=FMinorFont, write=SetMinorFont};
	__property double MinorUnit = {read=FMinorUnit, write=SetMinorUnit};
	__property bool MinorUnitVisible = {read=FMinorUnitVisible, write=SetMinorUnitVisible, default=1};
	__property int MinorUnitSpacing = {read=FMinorUnitSpacing, write=SetMinorUnitSpacing, default=2};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property TChartYAxisPosition Position = {read=FPosition, write=SetPosition, default=0};
	__property TChartXYAxisText* TextLeft = {read=FTextLeft, write=SetTextLeft};
	__property TChartXYAxisText* TextRight = {read=FTextRight, write=SetTextRight};
	__property Graphics::TColor TickMarkColor = {read=FTickMarkColor, write=SetTickMarkColor, default=536870911};
	__property int TickMarkSize = {read=FTickMarkSize, write=SetTickMarkSize, default=10};
	__property int TickMarkSizeMinor = {read=FTickMarkSizeMinor, write=SetTickMarkSizeMinor, default=7};
	__property int TickMarkWidth = {read=FTickMarkWidth, write=SetTickMarkWidth, default=1};
	__property bool Visible = {read=FVisible, write=SetVisible, default=1};
};


class DELPHICLASS TChartSerieXAxis;
class PASCALIMPLEMENTATION TChartSerieXAxis : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	AnsiString FDateTimeFormat;
	Graphics::TFont* FDateTimeFont;
	Graphics::TFont* FMajorFont;
	double FMajorUnit;
	int FMajorUnitSpacing;
	AnsiString FMajorUnitTimeFormat;
	Graphics::TFont* FMinorFont;
	double FMinorUnit;
	AnsiString FMinorUnitTimeFormat;
	int FMinorUnitSpacing;
	Classes::TNotifyEvent FOnChange;
	TChartXAxisPosition FPosition;
	TChartXYAxisText* FTextTop;
	TChartXYAxisText* FTextBottom;
	Graphics::TColor FTickMarkColor;
	int FTickMarkSize;
	int FTickMarkWidth;
	bool FVisible;
	bool FAutoUnits;
	int FXYValueOffset;
	bool FXYValues;
	void __fastcall SetMajorFont(const Graphics::TFont* Value);
	void __fastcall SetMajorUnit(const double Value);
	void __fastcall SetMajorUnitSpacing(const int Value);
	void __fastcall SetMajorUnitTimeFormat(const AnsiString Value);
	void __fastcall SetMinorFont(const Graphics::TFont* Value);
	void __fastcall SetMinorUnit(const double Value);
	void __fastcall SetMinorUnitSpacing(const int Value);
	void __fastcall SetMinorUnitTimeFormat(const AnsiString Value);
	void __fastcall SetPosition(const TChartXAxisPosition Value);
	void __fastcall SetTextBottom(const TChartXYAxisText* Value);
	void __fastcall SetTextTop(const TChartXYAxisText* Value);
	void __fastcall SetTickMarkColor(const Graphics::TColor Value);
	void __fastcall SetTickMarkSize(const int Value);
	void __fastcall SetTickMarkWidth(const int Value);
	void __fastcall SetVisible(const bool Value);
	void __fastcall SetDateTimeFormat(const AnsiString Value);
	void __fastcall SetDateTimeFont(const Graphics::TFont* Value);
	void __fastcall SetAutoUnits(const bool Value);
	void __fastcall SetXYValues(const bool Value);
	void __fastcall SetXYValuesOffset(const int Value);
	
protected:
	virtual void __fastcall Changed(void);
	void __fastcall FontChanged(System::TObject* Sender);
	void __fastcall TextTopChanged(System::TObject* Sender);
	void __fastcall TextBottomChanged(System::TObject* Sender);
	
public:
	__fastcall TChartSerieXAxis(void);
	__fastcall virtual ~TChartSerieXAxis(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property AnsiString DateTimeFormat = {read=FDateTimeFormat, write=SetDateTimeFormat};
	__property Graphics::TFont* DateTimeFont = {read=FDateTimeFont, write=SetDateTimeFont};
	__property Graphics::TFont* MajorFont = {read=FMajorFont, write=SetMajorFont};
	__property double MajorUnit = {read=FMajorUnit, write=SetMajorUnit};
	__property AnsiString MajorUnitTimeFormat = {read=FMajorUnitTimeFormat, write=SetMajorUnitTimeFormat};
	__property int MajorUnitSpacing = {read=FMajorUnitSpacing, write=SetMajorUnitSpacing, default=2};
	__property Graphics::TFont* MinorFont = {read=FMinorFont, write=SetMinorFont};
	__property double MinorUnit = {read=FMinorUnit, write=SetMinorUnit};
	__property AnsiString MinorUnitTimeFormat = {read=FMinorUnitTimeFormat, write=SetMinorUnitTimeFormat};
	__property int MinorUnitSpacing = {read=FMinorUnitSpacing, write=SetMinorUnitSpacing, default=2};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property TChartXAxisPosition Position = {read=FPosition, write=SetPosition, default=0};
	__property TChartXYAxisText* TextTop = {read=FTextTop, write=SetTextTop};
	__property TChartXYAxisText* TextBottom = {read=FTextBottom, write=SetTextBottom};
	__property Graphics::TColor TickMarkColor = {read=FTickMarkColor, write=SetTickMarkColor, default=0};
	__property int TickMarkSize = {read=FTickMarkSize, write=SetTickMarkSize, default=10};
	__property int TickMarkWidth = {read=FTickMarkWidth, write=SetTickMarkWidth, default=1};
	__property bool Visible = {read=FVisible, write=SetVisible, default=1};
	__property bool AutoUnits = {read=FAutoUnits, write=SetAutoUnits, default=1};
	__property bool XYValues = {read=FXYValues, write=SetXYValues, default=1};
	__property int XYValuesOffset = {read=FXYValueOffset, write=SetXYValuesOffset, default=0};
};


class DELPHICLASS TChartSerieCrossHairYValue;
class PASCALIMPLEMENTATION TChartSerieCrossHairYValue : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Graphics::TColor FBorderColor;
	int FBorderWidth;
	Graphics::TColor FColor;
	Graphics::TColor FColorTo;
	Graphics::TFont* FFont;
	int FGradientSteps;
	TChartGradientDirection FGradientDirection;
	Classes::TNotifyEvent FOnChange;
	Classes::TNotifyEvent FOnFontChange;
	bool FVisible;
	void __fastcall SetBorderColor(const Graphics::TColor Value);
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetColorTo(const Graphics::TColor Value);
	void __fastcall SetFont(const Graphics::TFont* Value);
	void __fastcall SetGradientDirection(const TChartGradientDirection Value);
	void __fastcall SetGradientSteps(const int Value);
	void __fastcall SetVisible(const bool Value);
	void __fastcall SetBorderWidth(const int Value);
	
protected:
	virtual void __fastcall Changed(void);
	
public:
	__fastcall TChartSerieCrossHairYValue(void);
	__fastcall virtual ~TChartSerieCrossHairYValue(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property Graphics::TColor BorderColor = {read=FBorderColor, write=SetBorderColor, default=536870911};
	__property int BorderWidth = {read=FBorderWidth, write=SetBorderWidth, default=1};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=536870911};
	__property Graphics::TColor ColorTo = {read=FColorTo, write=SetColorTo, default=536870911};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property TChartGradientDirection GradientDirection = {read=FGradientDirection, write=SetGradientDirection, default=0};
	__property int GradientSteps = {read=FGradientSteps, write=SetGradientSteps, default=100};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Classes::TNotifyEvent OnFontChange = {read=FOnFontChange, write=FOnFontChange};
	__property bool Visible = {read=FVisible, write=SetVisible, default=1};
};


typedef void __fastcall (__closure *TChartXAxisDrawValue)(System::TObject* Sender, TChartSerie* Serie, Graphics::TCanvas* Canvas, const Types::TRect &ARect, int ValueIndex, int XMarker, bool Top, bool &defaultdraw);

typedef void __fastcall (__closure *TChartYAxisDrawValue)(System::TObject* Sender, TChartSerie* Serie, Graphics::TCanvas* Canvas, const Types::TRect &ARect, double Value, bool Left, bool &defaultdraw);

typedef void __fastcall (__closure *TChartAxisGetValue)(System::TObject* Sender, TChartSerie* Serie, double Value, AnsiString &AValue);

typedef void __fastcall (__closure *TChartSerieMouseEvent)(System::TObject* Sender, Controls::TMouseButton Button, int PaneIndex, int SerieIndex, int Index, double value, int X, int Y);

#pragma option push -b-
enum TChartSerieAutoRange { arDisabled, arEnabled, arCommon, arEnabledZeroBased, arCommonZeroBased };
#pragma option pop

typedef DynamicArray<Types::TPoint >  TPointArray;

#pragma pack(push, 1)
struct TPointCheck
{
	Types::TPoint pt;
	bool valid;
} ;
#pragma pack(pop)

typedef DynamicArray<Types::TRect >  TRectArray;

typedef DynamicArray<TChartPoint >  TChartPointArray;

#pragma option push -b-
enum TAnnotationShape { asRectangle, asCircle, asRoundRect, asBalloon, asLine };
#pragma option pop

#pragma option push -b-
enum TAnnotationArrow { arLine, arStartArrow, arEndArrow, arDoubleArrow };
#pragma option pop

#pragma option push -b-
enum TAnnotationBalloonDirection { hdUpRight, hdUpLeft, hdDownRight, hdDownLeft };
#pragma option pop

class DELPHICLASS TChartAnnotation;
class PASCALIMPLEMENTATION TChartAnnotation : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	Classes::TPersistent* FOwner;
	Classes::TNotifyEvent FOnChange;
	Classes::TAlignment FTextHorizontalAlignment;
	TVerticalAlignment FTextVerticalAlignment;
	AnsiString FText;
	Graphics::TColor FColor;
	Graphics::TColor FColorTo;
	int FPointIndex;
	TAnnotationShape FShape;
	TAnnotationBalloonDirection FBalloonDirection;
	int FBalloonArrowSize;
	Graphics::TColor FBorderColor;
	int FBorderRounding;
	int FBorderWidth;
	int FLineWidth;
	Graphics::TColor FLineColor;
	Graphics::TFont* FFont;
	int FWidth;
	int FHeight;
	#pragma pack(push, 1)
	Types::TRect FAnnotationRect;
	#pragma pack(pop)
	
	bool FAutoSize;
	int FOffsetX;
	int FOffsetY;
	int FDisplayIndex;
	unsigned FClipRgn;
	TAnnotationArrow FArrow;
	int FGradientSteps;
	bool FWordWrap;
	AnsiString FName;
	int FArrowSize;
	Graphics::TColor FArrowColor;
	TChartGradientDirection FGradientDirection;
	bool FVisible;
	void __fastcall SetArrow(const TAnnotationArrow Value);
	void __fastcall SetAutoSize(const bool Value);
	void __fastcall SetBorderColor(const Graphics::TColor Value);
	void __fastcall SetBorderRounding(const int Value);
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetColorTo(const Graphics::TColor Value);
	void __fastcall SetFont(const Graphics::TFont* Value);
	void __fastcall SetGradientDirection(const TChartGradientDirection Value);
	void __fastcall SetGradientSteps(const int Value);
	void __fastcall SetHeight(const int Value);
	void __fastcall SetOffSetX(const int Value);
	void __fastcall SetOffSetY(const int Value);
	void __fastcall SetPointIndex(const int Value);
	void __fastcall SetShape(const TAnnotationShape Value);
	void __fastcall SetText(const AnsiString Value);
	void __fastcall SetWidth(const int Value);
	void __fastcall SetborderWidth(const int Value);
	void __fastcall SetWordWrap(const bool Value);
	void __fastcall SetBalloonDirection(const TAnnotationBalloonDirection Value);
	void __fastcall SetBalloonArrowSize(const int Value);
	void __fastcall SetArrowSize(const int Value);
	void __fastcall SetVisible(const bool Value);
	void __fastcall SetTextHorizontalAlignment(const Classes::TAlignment Value);
	void __fastcall SetTextVerticalAlignment(const TVerticalAlignment Value);
	void __fastcall SetArrowColor(const Graphics::TColor Value);
	void __fastcall SetLineColor(const Graphics::TColor Value);
	void __fastcall SetLineWidth(const int Value);
	void __fastcall SetName(const AnsiString Value);
	TChartSerie* __fastcall GetSerie(void);
	
protected:
	HIDESBASE virtual void __fastcall Changed(void);
	void __fastcall FontChanged(System::TObject* Sender);
	virtual Types::TRect __fastcall DrawBalloon(Graphics::TCanvas* Canvas, const Types::TRect &R, unsigned OldRgn, double ScaleX, double ScaleY);
	__property TChartSerie* Serie = {read=GetSerie};
	virtual void __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &DR, const Types::TRect &TextR, int xm, int ym, double ScaleX, double ScaleY);
	
public:
	__fastcall virtual TChartAnnotation(Classes::TCollection* Collection);
	__fastcall virtual ~TChartAnnotation(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property Types::TRect AnnotationRect = {read=FAnnotationRect};
	virtual void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	virtual void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	__property int DisplayIndex = {read=FDisplayIndex, write=FDisplayIndex, nodefault};
	
__published:
	__property AnsiString Name = {read=FName, write=SetName};
	__property Classes::TAlignment TextHorizontalAlignment = {read=FTextHorizontalAlignment, write=SetTextHorizontalAlignment, default=0};
	__property TVerticalAlignment TextVerticalAlignment = {read=FTextVerticalAlignment, write=SetTextVerticalAlignment, default=0};
	__property TAnnotationArrow Arrow = {read=FArrow, write=SetArrow, default=0};
	__property int ArrowSize = {read=FArrowSize, write=SetArrowSize, default=10};
	__property Graphics::TColor ArrowColor = {read=FArrowColor, write=SetArrowColor, default=536870911};
	__property bool AutoSize = {read=FAutoSize, write=SetAutoSize, default=1};
	__property TAnnotationBalloonDirection BalloonDirection = {read=FBalloonDirection, write=SetBalloonDirection, default=3};
	__property int BalloonArrowSize = {read=FBalloonArrowSize, write=SetBalloonArrowSize, default=15};
	__property Graphics::TColor BorderColor = {read=FBorderColor, write=SetBorderColor, default=0};
	__property int BorderRounding = {read=FBorderRounding, write=SetBorderRounding, default=0};
	__property int BorderWidth = {read=FBorderWidth, write=SetborderWidth, default=1};
	__property int LineWidth = {read=FLineWidth, write=SetLineWidth, default=1};
	__property Graphics::TColor LineColor = {read=FLineColor, write=SetLineColor, default=0};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=65535};
	__property Graphics::TColor ColorTo = {read=FColorTo, write=SetColorTo, default=536870911};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property int GradientSteps = {read=FGradientSteps, write=SetGradientSteps, default=100};
	__property TChartGradientDirection GradientDirection = {read=FGradientDirection, write=SetGradientDirection, default=1};
	__property int Height = {read=FHeight, write=SetHeight, default=0};
	__property int OffsetX = {read=FOffsetX, write=SetOffSetX, default=20};
	__property int OffsetY = {read=FOffsetY, write=SetOffSetY, default=20};
	__property TAnnotationShape Shape = {read=FShape, write=SetShape, default=0};
	__property AnsiString Text = {read=FText, write=SetText};
	__property int Width = {read=FWidth, write=SetWidth, default=0};
	__property bool WordWrap = {read=FWordWrap, write=SetWordWrap, default=0};
	__property bool Visible = {read=FVisible, write=SetVisible, default=1};
	__property int PointIndex = {read=FPointIndex, write=SetPointIndex, default=-1};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};


class DELPHICLASS TChartAnnotations;
class PASCALIMPLEMENTATION TChartAnnotations : public Classes::TOwnedCollection 
{
	typedef Classes::TOwnedCollection inherited;
	
public:
	TChartAnnotation* operator[](int Index) { return Items[Index]; }
	
private:
	TChartSerie* FOwner;
	Classes::TNotifyEvent FOnChange;
	HIDESBASE TChartAnnotation* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, const TChartAnnotation* Value);
	
protected:
	HIDESBASE virtual void __fastcall Changed(void);
	void __fastcall AnnotationChanged(System::TObject* Sender);
	virtual void __fastcall Update(Classes::TCollectionItem* Item);
	
public:
	__fastcall TChartAnnotations(TChartSerie* AOwner);
	__fastcall virtual ~TChartAnnotations(void);
	virtual TMetaClass* __fastcall GetItemClass(void);
	HIDESBASE TChartAnnotation* __fastcall Add(void);
	HIDESBASE TChartAnnotation* __fastcall Insert(int index);
	__property TChartAnnotation* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
	virtual void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	virtual void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};


#pragma option push -b-
enum TChartSeriePieValuePosition { vpInsideSlice, vpOutSideSlice };
#pragma option pop

#pragma option push -b-
enum TChartSeriePieSizeType { pstPixels, pstPercentage };
#pragma option pop

class DELPHICLASS TChartSeriePie;
class PASCALIMPLEMENTATION TChartSeriePie : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TChartSerie* FOwner;
	Classes::TNotifyEvent FOnChange;
	int FSize;
	TChartSeriePiePosition FPosition;
	int FInnerSize;
	bool FShowValues;
	int FStartOffsetAngle;
	Graphics::TFont* FValueFont;
	bool FLegendVisible;
	int FLegendLeft;
	int FLegendTop;
	TChartSeriePiePosition FLegendPosition;
	Graphics::TColor FLegendColor;
	Graphics::TColor FLegendBorderColor;
	int FLegendBorderWidth;
	int FLegendGradientSteps;
	TChartGradientDirection FLegendGradientDirection;
	Graphics::TColor FLegendColorTo;
	Graphics::TFont* FLegendFont;
	int FLegendTitleGradientSteps;
	TChartGradientDirection FLegendTitleGradientDirection;
	Graphics::TColor FLegendTitleColor;
	bool FLegendTitleVisible;
	Graphics::TColor FLegendTitleColorTo;
	int FTop;
	int FLeft;
	bool FShowGrid;
	bool FShowGridPieLines;
	TChartSeriePieValuePosition FValuePosition;
	bool FShowLegendOnSlice;
	TChartSeriePieSizeType FSizeType;
	void __fastcall SetPieSize(const int Value);
	void __fastcall SetLegendVisible(const bool Value);
	void __fastcall SetLegendFont(const Graphics::TFont* Value);
	void __fastcall SetLegendColor(const Graphics::TColor Value);
	void __fastcall SetLegendGradientDirection(const TChartGradientDirection Value);
	void __fastcall SetLegendGradientSteps(const int Value);
	void __fastcall SetLegendBorderColor(const Graphics::TColor Value);
	void __fastcall SetLegendBorderWidth(const int Value);
	void __fastcall SetLegendColorTo(const Graphics::TColor Value);
	void __fastcall SetShowValues(const bool Value);
	void __fastcall SetValueFont(const Graphics::TFont* Value);
	void __fastcall SetStartOffsetAngle(const int Value);
	void __fastcall SetLegendOffSetLeft(const int Value);
	void __fastcall SetLegendOffSetTop(const int Value);
	void __fastcall SetInnerSize(const int Value);
	void __fastcall SetLegendTitleColor(const Graphics::TColor Value);
	void __fastcall SetLegendTitleGradientSteps(const int Value);
	void __fastcall SetLegendTitleVisible(const bool Value);
	void __fastcall SetLegendTitleGradientDirection(const TChartGradientDirection Value);
	void __fastcall SetLegendTitleColorTo(const Graphics::TColor Value);
	void __fastcall SetPosition(const TChartSeriePiePosition Value);
	void __fastcall SetLeft(const int Value);
	void __fastcall SetTop(const int Value);
	void __fastcall SetLegendPosition(const TChartSeriePiePosition Value);
	void __fastcall SetShowGrid(const bool Value);
	void __fastcall SetShowGridPieLines(const bool Value);
	void __fastcall SetValuePosition(const TChartSeriePieValuePosition Value);
	void __fastcall SetShowLegendOnSlice(const bool Value);
	void __fastcall SetSizeType(const TChartSeriePieSizeType Value);
	
protected:
	virtual void __fastcall Changed(void);
	void __fastcall FontChanged(System::TObject* Sender);
	
public:
	__fastcall virtual TChartSeriePie(TChartSerie* AOwner);
	__fastcall virtual ~TChartSeriePie(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	int __fastcall GetPieSize(void);
	int __fastcall GetPieInnerSize(void);
	virtual void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	virtual void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	
__published:
	__property TChartSeriePiePosition Position = {read=FPosition, write=SetPosition, default=7};
	__property TChartSeriePiePosition LegendPosition = {read=FLegendPosition, write=SetLegendPosition, default=8};
	__property int Left = {read=FLeft, write=SetLeft, default=0};
	__property int Top = {read=FTop, write=SetTop, default=0};
	__property int Size = {read=FSize, write=SetPieSize, default=200};
	__property TChartSeriePieSizeType SizeType = {read=FSizeType, write=SetSizeType, default=0};
	__property int InnerSize = {read=FInnerSize, write=SetInnerSize, default=50};
	__property bool ShowValues = {read=FShowValues, write=SetShowValues, default=0};
	__property TChartSeriePieValuePosition ValuePosition = {read=FValuePosition, write=SetValuePosition, default=0};
	__property bool ShowGrid = {read=FShowGrid, write=SetShowGrid, default=1};
	__property bool ShowGridPieLines = {read=FShowGridPieLines, write=SetShowGridPieLines, default=1};
	__property bool ShowLegendOnSlice = {read=FShowLegendOnSlice, write=SetShowLegendOnSlice, default=0};
	__property int StartOffsetAngle = {read=FStartOffsetAngle, write=SetStartOffsetAngle, default=0};
	__property Graphics::TFont* ValueFont = {read=FValueFont, write=SetValueFont};
	__property bool LegendVisible = {read=FLegendVisible, write=SetLegendVisible, default=1};
	__property int LegendOffsetLeft = {read=FLegendLeft, write=SetLegendOffSetLeft, default=0};
	__property int LegendOffsetTop = {read=FLegendTop, write=SetLegendOffSetTop, default=0};
	__property Graphics::TFont* LegendFont = {read=FLegendFont, write=SetLegendFont};
	__property Graphics::TColor LegendColor = {read=FLegendColor, write=SetLegendColor, default=16777215};
	__property Graphics::TColor LegendColorTo = {read=FLegendColorTo, write=SetLegendColorTo, default=16777215};
	__property int LegendGradientSteps = {read=FLegendGradientSteps, write=SetLegendGradientSteps, default=32};
	__property TChartGradientDirection LegendGradientDirection = {read=FLegendGradientDirection, write=SetLegendGradientDirection, default=0};
	__property Graphics::TColor LegendBorderColor = {read=FLegendBorderColor, write=SetLegendBorderColor, default=0};
	__property int LegendBorderWidth = {read=FLegendBorderWidth, write=SetLegendBorderWidth, default=1};
	__property bool LegendTitleVisible = {read=FLegendTitleVisible, write=SetLegendTitleVisible, default=0};
	__property Graphics::TColor LegendTitleColor = {read=FLegendTitleColor, write=SetLegendTitleColor, default=8421504};
	__property Graphics::TColor LegendTitleColorTo = {read=FLegendTitleColorTo, write=SetLegendTitleColorTo, default=12632256};
	__property int LegendTitleGradientSteps = {read=FLegendTitleGradientSteps, write=SetLegendTitleGradientSteps, default=32};
	__property TChartGradientDirection LegendTitleGradientDirection = {read=FLegendTitleGradientDirection, write=SetLegendTitleGradientDirection, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};


#pragma pack(push, 4)
struct TSlicePoint
{
	int X0;
	int Y0;
	int X1;
	int Y1;
	int X2;
	int Y2;
} ;
#pragma pack(pop)

#pragma pack(push, 4)
struct TBarRec
{
	Graphics::TColor SColor;
	Graphics::TColor SColorTo;
	Types::TRect R;
} ;
#pragma pack(pop)

typedef DynamicArray<TBarRec >  TBarArray;

#pragma option push -b-
enum TPieQuadrant { pq1, pq2, pq3, pq4 };
#pragma option pop

typedef DynamicArray<TSlicePoint >  TPointSliceArray;

#pragma option push -b-
enum TSerieType { stNormal, stZoomControl, stBoth };
#pragma option pop

typedef void __fastcall (__closure *TChartSerieSliceGetValue)(System::TObject* Sender, int Serie, AnsiString legendtext, double value, int valuepointindex, Types::TPoint &valueposition, AnsiString &valuestring);

#pragma option push -b-
enum TChartBarShape { bsRectangle, bsCylinder, bsPyramid };
#pragma option pop

#pragma option push -b-
enum TChartBarValueTextType { btCustomValue, btXAxisValue };
#pragma option pop

typedef void __fastcall (__closure *TChartGetBarValueTextEvent)(System::TObject* Sender, int Serie, int PointIndex, Graphics::TFont* AFont, AnsiString &BarText, Classes::TAlignment &Alignment);

typedef void __fastcall (__closure *TChartSerieDrawPoint)(System::TObject* Sender, Graphics::TCanvas* ACanvas, const Types::TPoint &APoint, const TChartPoint &AChartPoint);

#pragma option push -b-
enum TChartValueFormatType { vftNormal, vftFloat };
#pragma option pop

class PASCALIMPLEMENTATION TChartSerie : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	int FDPI;
	DynamicArray<Types::TPoint >  FDrawValuesDP;
	DynamicArray<TSlicePoint >  FDrawValuesSlice;
	TChartSeriePie* FPie;
	bool FShowAnnotationsOnTop;
	TChartSerieAutoRange FAutoRange;
	TChartBackGroundPosition FChartPatternPosition;
	Graphics::TColor FArrowColor;
	int FArrowSize;
	int FBorderwidth;
	Graphics::TColor FBorderColor;
	int FBorderRounding;
	Graphics::TBrushStyle FBrushStyle;
	Graphics::TColor FCandleColorIncrease;
	Graphics::TColor FCandleColorDecrease;
	TChartType FChartType;
	unsigned FClipRgn;
	Graphics::TColor FColor;
	Graphics::TColor FColorTo;
	TChartSerieCrossHairYValue* FCrossHairYValue;
	bool FDrawMajorValue;
	bool FDrawMinorValue;
	DynamicArray<Types::TPoint >  FPointsLineBar;
	DynamicArray<Types::TPoint >  FStackedPointsBar;
	DynamicArray<TBarRec >  FStackedRectsBar;
	DynamicArray<Types::TPoint >  FStackedPointsArea;
	DynamicArray<Types::TPoint >  FSpiderV;
	DynamicArray<Types::TPoint >  FDrawPoints;
	DynamicArray<Types::TPoint >  FDrawValues;
	bool FForceInit;
	double Ffirstpoint;
	int FGradientSteps;
	TChartGradientDirection FGradientDirection;
	bool FIsDrawing;
	int FItemIndex;
	int FLastPoint;
	AnsiString FLegendText;
	Graphics::TColor FLineColor;
	int FLineWidth;
	TChartMarker* FMarker;
	TChartAnnotations* FAnnotations;
	double FMax;
	double FMaximumValue;
	int FMi;
	double FMin;
	double FMinimumDistance;
	double FMinimumValue;
	int FMu;
	double FNextPoint;
	double FOffSet;
	#pragma pack(push, 1)
	Types::TRect FOldRect;
	#pragma pack(pop)
	
	double FOldYScale;
	Classes::TNotifyEvent FOnChange;
	double FOriginalYScale;
	TChartXAxisDrawValue FOnXAxisDrawValue;
	TChartYAxisDrawValue FOnYAxisDrawValue;
	TChartAxisGetValue FOnYAxisGetValue;
	TChartAxisGetValue FOnXAxisGetValue;
	TChartMarkerDrawEvent FOnMarkerDrawValue;
	TChartSerieMouseEvent FOnSerieMouseDown;
	TChartSerieMouseEvent FOnSerieMouseUp;
	Graphics::TPenStyle FPenStyle;
	DynamicArray<TChartPoint >  FPoints;
	Graphics::TPicture* FChartPattern;
	double FSerieMin;
	double FSerieMax;
	bool FShowValue;
	Graphics::TFont* FValueFont;
	int FValueAngle;
	AnsiString FValueFormat;
	TChartValueType FValueType;
	int FValueWidth;
	TChartSerieValueWidthType FValueWidthType;
	Graphics::TColor FWickColor;
	int FWickWidth;
	TChartSerieXAxis* FXAxis;
	int FXMarker;
	int FLastXVal;
	int FLastXMarker;
	TChartSerieYAxis* FYAxis;
	double FYScale;
	bool FZeroLine;
	Graphics::TColor FZeroLineColor;
	int FZeroLineWidth;
	double FZeroReferencePoint;
	bool FShowValueInTracker;
	int FCrosshairFontHeight;
	AnsiString FName;
	bool FReadOnly;
	int FSelectedIndex;
	Graphics::TColor FSelectedMarkBorderColor;
	Graphics::TColor FSelectedColor;
	int FSelectedMarkSize;
	bool FSelectedMark;
	AnsiString FFieldNameValue;
	AnsiString FFieldNameXAxis;
	TSerieType FSerieType;
	bool FShowInLegend;
	int FOffset3D;
	bool FEnable3D;
	TChartSerieSliceGetValue FOnSerieSliceGetValue;
	bool FDarken3D;
	TChartBarShape FBarShape;
	bool FLogarithmic;
	Graphics::TFont* FBarValueTextFont;
	Classes::TAlignment FBarValueTextAlignment;
	TChartBarValueTextType FBarValueTextType;
	TChartGetBarValueTextEvent FOnGetBarValueText;
	TChartSerieDrawPoint FOnSerieDrawPoint;
	bool FVisible;
	TChartAxisGetValue FOnXAxisGetXValue;
	TChartXAxisDrawValue FOnXAxisDrawXValue;
	int FMaximumPoints;
	bool FUseFullRange;
	int FRangePercentMargin;
	TChartSerieXAxisGroups* FXAxisGroups;
	bool FXAxisGroupsVisible;
	int FGroupIndex;
	TChartValueFormatType FValueFormatType;
	int FGanttSpacing;
	int FGanttHeight;
	bool FDrawFromStartDate;
	int FTag;
	void __fastcall SetAutoRange(const TChartSerieAutoRange Value);
	void __fastcall SetBorderColor(const Graphics::TColor Value);
	void __fastcall SetBorderWidth(const int Value);
	void __fastcall SetBrushStyle(const Graphics::TBrushStyle Value);
	void __fastcall SetCandleColorDecrease(const Graphics::TColor Value);
	void __fastcall SetCandleColorIncrease(const Graphics::TColor Value);
	void __fastcall SetChartType(const TChartType Value);
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetColorTo(const Graphics::TColor Value);
	void __fastcall SetCrossHairYValue(const TChartSerieCrossHairYValue* Value);
	void __fastcall SetGradientDirection(const TChartGradientDirection Value);
	void __fastcall SetGradientSteps(const int Value);
	void __fastcall SetLegendText(const AnsiString Value);
	void __fastcall SetLineColor(const Graphics::TColor Value);
	void __fastcall SetLineWidth(const int Value);
	void __fastcall SetMax(const double Value);
	void __fastcall SetMin(const double Value);
	void __fastcall SetOffset(const double Value);
	void __fastcall SetOldYScale(const double Value);
	void __fastcall SetOriginalYScale(const double Value);
	void __fastcall SetPenStyle(const Graphics::TPenStyle Value);
	void __fastcall SetChartPattern(const Graphics::TPicture* Value);
	void __fastcall SetShowValue(const bool Value);
	void __fastcall SetValueFormat(const AnsiString Value);
	void __fastcall SetValueType(const TChartValueType Value);
	void __fastcall SetValueWidth(const int Value);
	void __fastcall SetValueWidthType(const TChartSerieValueWidthType Value);
	void __fastcall SetWickColor(const Graphics::TColor Value);
	void __fastcall SetWickWidth(const int Value);
	void __fastcall SetXAxis(const TChartSerieXAxis* Value);
	void __fastcall SetYAxis(const TChartSerieYAxis* Value);
	void __fastcall SetYScale(const double Value);
	void __fastcall SetZeroLine(const bool Value);
	void __fastcall SetZeroLineColor(const Graphics::TColor Value);
	void __fastcall SetZeroLineWidth(const int Value);
	void __fastcall SetZeroReferencePoint(const double Value);
	void __fastcall SetShowValueInTracker(const bool Value);
	void __fastcall DrawDateTimeValues(AnsiString DateTimeFormat, int ValueIndex, Graphics::TCanvas* Canvas, const Types::TRect &Rect, int m);
	TAdvChart* __fastcall GetChart(void);
	void __fastcall SetChartPatternPosition(const TChartBackGroundPosition Value);
	void __fastcall SetName(const AnsiString Value);
	void __fastcall SetBorderRounding(const int Value);
	void __fastcall SetShowAnnotationsOnTop(const bool Value);
	void __fastcall SetArrowColor(const Graphics::TColor Value);
	void __fastcall SetArrowSize(const int Value);
	void __fastcall SetValueAngle(const int Value);
	void __fastcall SetValueFont(const Graphics::TFont* Value);
	void __fastcall SetReadOnly(const bool Value);
	void __fastcall SetSelectedIndex(const int Value);
	void __fastcall SetSelectedColor(const Graphics::TColor Value);
	void __fastcall SetSelectedMarkBorderColor(const Graphics::TColor Value);
	void __fastcall SetSelectedMarkSize(const int Value);
	void __fastcall SetSelectedMark(const bool Value);
	void __fastcall SetSerieType(const TSerieType Value);
	void __fastcall SetShowInLegend(const bool Value);
	void __fastcall SetEnable3D(const bool Value);
	void __fastcall SetOffset3D(const int Value);
	void __fastcall SetDarken3D(const bool Value);
	void __fastcall SetBarShape(const TChartBarShape Value);
	void __fastcall SetLogarithmic(const bool Value);
	void __fastcall SetBarValueTextAlignment(const Classes::TAlignment Value);
	void __fastcall SetBarValueTextFont(const Graphics::TFont* Value);
	void __fastcall SetBarValueTextType(const TChartBarValueTextType Value);
	void __fastcall SetVisible(const bool Value);
	void __fastcall SetRangePercentMargin(const int Value);
	void __fastcall SetXAxisGroups(const TChartSerieXAxisGroups* Value);
	void __fastcall SetXAxisGroupsVisible(const bool Value);
	void __fastcall SetGroupIndex(const int Value);
	void __fastcall SetValueFormatType(const TChartValueFormatType Value);
	void __fastcall SetGanttHeight(const int Value);
	void __fastcall SetGanttSpacing(const int Value);
	void __fastcall SetDrawFromStartDate(const bool Value);
	
protected:
	int __fastcall GetMaxLevel(int Level);
	int __fastcall GetYMajorUnitSpacing(bool Right);
	int __fastcall GetYMinorUnitSpacing(bool Right);
	int __fastcall GetXMajorUnitSpacing(bool Bottom);
	int __fastcall GetXMinorUnitSpacing(bool Bottom);
	int __fastcall GetXAxisValueSize(System::TObject* Sender, TChartSerie* Serie, Graphics::TCanvas* Canvas, int ValueIndex, double ScaleX, double ScaleY, bool DrawCustomValues, bool &defaultdraw);
	HIDESBASE virtual void __fastcall Changed(void);
	void __fastcall FontChanged(System::TObject* Sender);
	void __fastcall MarkerChanged(System::TObject* Sender);
	void __fastcall PieChanged(System::TObject* Sender);
	void __fastcall AnnotationChanged(System::TObject* Sender);
	void __fastcall PictureChanged(System::TObject* Sender);
	void __fastcall XAxisChanged(System::TObject* Sender);
	int __fastcall GetPreviousGanttGroupHeight(void);
	void __fastcall YAxisChanged(System::TObject* Sender);
	void __fastcall CrossHairYValueChanged(System::TObject* Sender);
	void __fastcall CrossHairYValueFontChanged(System::TObject* Sender);
	virtual void __fastcall DrawMarker(System::TObject* Sender, Graphics::TCanvas* Canvas, int x, int y, int point, const TChartPoint &value);
	virtual AnsiString __fastcall GetDisplayName();
	__property bool IsDrawing = {read=FIsDrawing, write=FIsDrawing, nodefault};
	virtual void __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	virtual void __fastcall DrawPyramid(Graphics::TCanvas* Canvas, Graphics::TColor SColor, Graphics::TColor SColorTo, const Types::TRect &Dr, double ScaleX, double ScaleY, int Idx, double val);
	void __fastcall DrawGanttBar(Graphics::TCanvas* Canvas, const TChartPoint &pt, const Types::TRect &dr, double ScaleX, double ScaleY);
	virtual void __fastcall DrawGanttBarRect(Graphics::TCanvas* Canvas, const TChartPoint &pt, const Types::TRect &dr);
	virtual void __fastcall DrawBar(Graphics::TCanvas* Canvas, Graphics::TColor SColor, Graphics::TColor SColorTo, const Types::TRect &dr, double ScaleX, double ScaleY, int Idx, double Val);
	virtual void __fastcall Draw3DBar(Graphics::TCanvas* canvas, Graphics::TColor SColor, Graphics::TColor SColorTo, const Types::TRect &dr, double ScaleX, double ScaleY);
	virtual void __fastcall DrawPicture(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	virtual void __fastcall DrawXValues(Graphics::TCanvas* Canvas, const Types::TRect &R, int XAxisY, bool Top, double ScaleX, double ScaleY);
	void __fastcall DrawTotalGrid(Graphics::TCanvas* Canvas, const Types::TRect &R, const Types::TPoint &Center, double ScaleX, double ScaleY);
	void __fastcall DrawTotalGridValues(Graphics::TCanvas* Canvas, const Types::TRect &R, const Types::TPoint &Center, double ScaleX, double ScaleY);
	void __fastcall DrawGridCircles(Graphics::TCanvas* Canvas, const Types::TPoint &center, const Types::TRect &R, TChartYGrid* YG, double mu, double mi, double ys, double ScaleX, double ScaleY);
	void __fastcall DrawGridValues(Graphics::TCanvas* Canvas, const Types::TPoint &center, const Types::TRect &R, TChartSerieYAxis* Y, double mu, double mi, double ys, double ScaleX, double ScaleY);
	virtual void __fastcall DrawGridValue(Graphics::TCanvas* Canvas, TChartSerieYAxis* Y, const Types::TPoint &Center, AnsiString Value, bool Major);
	virtual void __fastcall DrawGridCircle(Graphics::TCanvas* Canvas, TChartYGrid* YG, const Types::TPoint &Center, int diff, bool Major);
	virtual void __fastcall DrawGridPieLine(Graphics::TCanvas* Canvas, TChartYGrid* YG, const Types::TPoint &Center, int x, int y);
	virtual void __fastcall DrawYValues(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	virtual void __fastcall DrawMarkers(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	virtual Types::TRect __fastcall DrawLegend(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY, bool Draw);
	virtual void __fastcall DrawAnnotations(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	void __fastcall DrawTickMark(Graphics::TCanvas* Canvas, TChartSerieXAxis* x, bool Top, const Types::TRect &Rect, double Scalex, double ScaleY);
	virtual void __fastcall DrawPieLegend(Graphics::TCanvas* Canvas, int x, int y, int width, int height, double Scalex, double ScaleY);
	virtual void __fastcall DrawPieSlice(Graphics::TCanvas* Canvas, const Types::TPoint &Center, int Radius, int centerh, int centerv, int indent, double StartAngle, double SweepAngle, int PointIndex, double ScaleX, double ScaleY);
	virtual void __fastcall DrawSpiderArea(Graphics::TCanvas* Canvas, const Types::TRect &R, TPointArray SpiderArea, double ScaleX, double ScaleY);
	virtual void __fastcall DrawPieValues(Graphics::TCanvas* Canvas, int indent, const Types::TPoint &Center, double radius, double StartAngle, double SweepAngle, int PointIndex, double ScaleX, double ScaleY);
	void __fastcall DrawValues(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	virtual void __fastcall DrawSelected(Graphics::TCanvas* ACanvas, const Types::TRect &r);
	virtual void __fastcall DrawSelectedSlice(Graphics::TCanvas* ACanvas, const TSlicePoint &ptslice);
	void __fastcall Draw3DPolygons(Graphics::TCanvas* ACanvas, int dpcfrom, int dpcto, TPointArray dp, int pci, TChartSerie* s, double ScaleX, double ScaleY);
	int __fastcall GetYValuesSize(const Types::TRect &R, Graphics::TCanvas* Canvas, double ScaleX, double ScaleY);
	int __fastcall GetXValuesSize(Graphics::TCanvas* Canvas, double ScaleX, double ScaleY, int &totalxSize);
	virtual TChartAnnotations* __fastcall CreateAnnotations(void);
	virtual TChartSeriePie* __fastcall CreatePie(void);
	virtual TChartMarker* __fastcall CreateMarker(void);
	__property double MaximumValue = {read=FMaximumValue, write=FMaximumValue};
	__property double MinimumValue = {read=FMinimumValue, write=FMinimumValue};
	void __fastcall InitializeLineColor(Graphics::TCanvas* Canvas, double Scalex, double ScaleY);
	void __fastcall InitializeBorderColor(Graphics::TCanvas* Canvas, double Scalex, double ScaleY);
	void __fastcall InitializePieLegendBorderColor(Graphics::TCanvas* Canvas, double Scalex, double ScaleY);
	void __fastcall InitializeBrushColor(Graphics::TCanvas* Canvas);
	void __fastcall InitializePieLegendBrushColor(Graphics::TCanvas* Canvas);
	void __fastcall InitializeWickColor(Graphics::TCanvas* Canvas, double ScaleX, double ScaleY);
	double __fastcall SerieMax(void);
	double __fastcall SerieMin(void);
	virtual void __fastcall SetFieldNameValue(const AnsiString Value);
	virtual void __fastcall SetFieldNameXAxis(const AnsiString Value);
	bool __fastcall IsPieChart(void);
	TPieQuadrant __fastcall GetQuadrant(const Types::TPoint &center, const Types::TPoint &pt);
	int __fastcall Get3DOffset(void);
	bool __fastcall IsEnabled3D(void);
	bool __fastcall IsHalfPie(void);
	virtual Classes::TStringList* __fastcall GetDSFieldNames(void);
	virtual bool __fastcall IsDB(void);
	__property AnsiString FieldNameValue = {read=FFieldNameValue, write=FFieldNameValue};
	__property AnsiString FieldNameXAxis = {read=FFieldNameXAxis, write=FFieldNameXAxis};
	__property TSerieType SerieType = {read=FSerieType, write=SetSerieType, nodefault};
	
public:
	__fastcall virtual TChartSerie(Classes::TCollection* Collection);
	__fastcall virtual ~TChartSerie(void);
	__property TPointArray StackedPointsBar = {read=FStackedPointsBar, write=FStackedPointsBar};
	__property TPointArray StackedPointsArea = {read=FStackedPointsArea, write=FStackedPointsArea};
	void __fastcall SetStackedPointsBarLength(int l);
	void __fastcall SetStackedPointsAreaLength(int l);
	__property TPointArray DrawPoints = {read=FDrawPoints, write=FDrawPoints};
	__property TPointArray SpiderV = {read=FSpiderV, write=FSpiderV};
	__property TPointArray DrawValuesDP = {read=FDrawValuesDP, write=FDrawValuesDP};
	__property TPointSliceArray DrawValuesSlice = {read=FDrawValuesSlice, write=FDrawValuesSlice};
	void __fastcall AssignPrivates(Classes::TPersistent* Source);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall InitializeDrawPoints(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	void __fastcall SetMinMax(int RangeFrom, int RangeTo);
	void __fastcall SetArraySize(int Size);
	int __fastcall GetArraySize(void);
	int __fastcall GetLastPoint(void);
	bool __fastcall PointInPie(int x, int y, int x0, int y0, int x1, int y1, int x2, int y2);
	__property TAdvChart* Chart = {read=GetChart};
	__property TChartPointArray Points = {read=FPoints, write=FPoints};
	__property int CrosshairFontHeight = {read=FCrosshairFontHeight, nodefault};
	void __fastcall AddChartPoint(const TChartPoint &pt);
	void __fastcall SetSingleDateTime(System::TDateTime SingleDateTime, int index);
	void __fastcall SetSinglePoint(double SinglePoint, int index);
	void __fastcall RemovePoint(int PointIndex);
	void __fastcall AddSinglePoint(AnsiString Text, System::TDateTime SingleDateTimeStart, System::TDateTime SingleDateTimeEnd, Graphics::TColor Color = (Graphics::TColor)(0xffffff), Graphics::TColor ColorTo = (Graphics::TColor)(0x1fffffff), Graphics::TColor BorderColor = (Graphics::TColor)(0x0), Graphics::TColor TextColor = (Graphics::TColor)(0x0), TChartGradientDirection GradientDirection = (TChartGradientDirection)(0x1))/* overload */;
	void __fastcall AddSinglePoint(double SingleValueStart, double SingleValueEnd, AnsiString Text, Graphics::TColor Color = (Graphics::TColor)(0xffffff), Graphics::TColor ColorTo = (Graphics::TColor)(0x1fffffff), Graphics::TColor BorderColor = (Graphics::TColor)(0x0), Graphics::TColor TextColor = (Graphics::TColor)(0x0), TChartGradientDirection GradientDirection = (TChartGradientDirection)(0x1))/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, bool Defined)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, System::TDateTime SingleDateTime)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, System::TDateTime SingleDateTime, bool Defined)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, Graphics::TColor Color)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, Graphics::TColor Color, bool Defined)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, System::TDateTime SingleDateTime, Graphics::TColor Color)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, System::TDateTime SingleDateTime, Graphics::TColor Color, bool Defined)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, bool Defined, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, System::TDateTime SingleDateTime, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, System::TDateTime SingleDateTime, bool Defined, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, Graphics::TColor Color, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, Graphics::TColor Color, bool Defined, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, System::TDateTime SingleDateTime, Graphics::TColor Color, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, System::TDateTime SingleDateTime, Graphics::TColor Color, bool Defined, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSinglePoint(double SinglePoint, Graphics::TColor Color, Graphics::TColor ColorTo, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, bool Defined)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, bool Defined)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, System::TDateTime SingleXDateTime)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, System::TDateTime SingleXDateTime, bool Defined)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, Graphics::TColor Color)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, Graphics::TColor Color, bool Defined)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, Graphics::TColor Color)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, Graphics::TColor Color, bool Defined)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, System::TDateTime SingleXDateTime, Graphics::TColor Color)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, System::TDateTime SingleXDateTime, Graphics::TColor Color, bool Defined)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, bool Defined, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, bool Defined, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, System::TDateTime SingleXDateTime, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, System::TDateTime SingleXDateTime, bool Defined, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, Graphics::TColor Color, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, Graphics::TColor Color, bool Defined, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, Graphics::TColor Color, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, Graphics::TColor Color, bool Defined, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, System::TDateTime SingleXDateTime, Graphics::TColor Color, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, System::TDateTime SingleDateTime, System::TDateTime SingleXDateTime, Graphics::TColor Color, bool Defined, AnsiString XAxisValue)/* overload */;
	void __fastcall AddSingleXYPoint(double SingleXPoint, double SingleYPoint, Graphics::TColor Color, Graphics::TColor ColorTo, AnsiString XAxisValue)/* overload */;
	void __fastcall AddDoublePoint(double FirstPoint, double SecondPoint, AnsiString XAxisValue)/* overload */;
	void __fastcall AddDoublePoint(double FirstPoint, double SecondPoint)/* overload */;
	void __fastcall AddDoublePoint(double FirstPoint, double SecondPoint, bool Defined)/* overload */;
	void __fastcall AddDoublePoint(double FirstPoint, double SecondPoint, System::TDateTime SingleDateTime)/* overload */;
	void __fastcall AddDoublePoint(double FirstPoint, double SecondPoint, System::TDateTime SingleDateTime, bool Defined)/* overload */;
	void __fastcall AddDoublePoint(double FirstPoint, double SecondPoint, Graphics::TColor Color)/* overload */;
	void __fastcall AddDoublePoint(double FirstPoint, double SecondPoint, Graphics::TColor Color, bool Defined)/* overload */;
	void __fastcall AddDoublePoint(double FirstPoint, double SecondPoint, System::TDateTime SingleDateTime, Graphics::TColor Color)/* overload */;
	void __fastcall AddDoublePoint(double FirstPoint, double SecondPoint, System::TDateTime SingleDateTime, Graphics::TColor Color, bool Defined)/* overload */;
	void __fastcall AddDoubleXYPoint(double SingleXPoint, double FirstPoint, double SecondPoint, AnsiString XAxisValue)/* overload */;
	void __fastcall AddDoubleXYPoint(double SingleXPoint, double FirstPoint, double SecondPoint)/* overload */;
	void __fastcall AddDoubleXYPoint(double SingleXPoint, double FirstPoint, double SecondPoint, bool Defined)/* overload */;
	void __fastcall AddDoubleXYPoint(double SingleXPoint, double FirstPoint, double SecondPoint, System::TDateTime SingleDateTime)/* overload */;
	void __fastcall AddDoubleXYPoint(double SingleXPoint, double FirstPoint, double SecondPoint, System::TDateTime SingleDateTime, bool Defined)/* overload */;
	void __fastcall AddDoubleXYPoint(double SingleXPoint, double FirstPoint, double SecondPoint, Graphics::TColor Color)/* overload */;
	void __fastcall AddDoubleXYPoint(double SingleXPoint, double FirstPoint, double SecondPoint, Graphics::TColor Color, bool Defined)/* overload */;
	void __fastcall AddDoubleXYPoint(double SingleXPoint, double FirstPoint, double SecondPoint, System::TDateTime SingleDateTime, Graphics::TColor Color)/* overload */;
	void __fastcall AddDoubleXYPoint(double SingleXPoint, double FirstPoint, double SecondPoint, System::TDateTime SingleDateTime, Graphics::TColor Color, bool Defined)/* overload */;
	void __fastcall ClearPoints(void);
	void __fastcall SetMultiPoints(double HighPoint, double LowPoint, double OpenPoint, double ClosePoint, int index);
	void __fastcall AddPoints(double SinglePoint, int PixelValue)/* overload */;
	void __fastcall AddPiePoints(double SinglePoint, Graphics::TColor Color = (Graphics::TColor)(0x1fffffff), Graphics::TColor ColorTo = (Graphics::TColor)(0x1fffffff), int PieIndent = 0x0, bool Defined = true)/* overload */;
	void __fastcall AddPiePoints(double SinglePoint, AnsiString legendvalue = "", Graphics::TColor Color = (Graphics::TColor)(0x1fffffff), Graphics::TColor ColorTo = (Graphics::TColor)(0x1fffffff), int PieIndent = 0x0, bool Defined = true)/* overload */;
	void __fastcall AddPiePoints(double SinglePoint, double RadiusValue, AnsiString legendvalue = "", Graphics::TColor Color = (Graphics::TColor)(0x1fffffff), Graphics::TColor ColorTo = (Graphics::TColor)(0x1fffffff), int PieIndent = 0x0, bool Defined = true)/* overload */;
	void __fastcall AddPiePoints(double SinglePoint, double RadiusValue, Graphics::TColor Color = (Graphics::TColor)(0x1fffffff), Graphics::TColor ColorTo = (Graphics::TColor)(0x1fffffff), int PieIndent = 0x0, bool Defined = true)/* overload */;
	void __fastcall AddPoints(double SinglePoint, int PixelValue1, int PixelValue2)/* overload */;
	void __fastcall AddPoints(double SinglePoint, int PixelValue1, int PixelValue2, bool Defined)/* overload */;
	void __fastcall AddPoints(double SinglePoint, int PixelValue1, int PixelValue2, System::TDateTime SingleDateTime)/* overload */;
	void __fastcall AddPoints(double SinglePoint, int PixelValue1, int PixelValue2, System::TDateTime SingleDateTime, bool Defined)/* overload */;
	void __fastcall AddMultiPoints(double HighPoint, double LowPoint, double OpenPoint, double ClosePoint, AnsiString XAxisValue)/* overload */;
	void __fastcall AddMultiPoints(double HighPoint, double LowPoint, double OpenPoint, double ClosePoint)/* overload */;
	void __fastcall AddMultiPoints(double HighPoint, double LowPoint, double OpenPoint, double ClosePoint, bool Defined)/* overload */;
	void __fastcall AddMultiPoints(double HighPoint, double LowPoint, double OpenPoint, double ClosePoint, System::TDateTime SingleDateTime)/* overload */;
	void __fastcall AddMultiPoints(double HighPoint, double LowPoint, double OpenPoint, double ClosePoint, System::TDateTime SingleDateTime, bool Defined)/* overload */;
	void __fastcall AddMultiPoints(double HighPoint, double LowPoint, double OpenPoint, double ClosePoint, Graphics::TColor Color)/* overload */;
	void __fastcall AddMultiPoints(double HighPoint, double LowPoint, double OpenPoint, double ClosePoint, Graphics::TColor Color, bool Defined)/* overload */;
	void __fastcall AddMultiPoints(double HighPoint, double LowPoint, double OpenPoint, double ClosePoint, System::TDateTime SingleDateTime, Graphics::TColor Color)/* overload */;
	void __fastcall AddMultiPoints(double HighPoint, double LowPoint, double OpenPoint, double ClosePoint, System::TDateTime SingleDateTime, Graphics::TColor Color, bool Defined)/* overload */;
	void __fastcall AddMultiPoints(double Minimum, double Q1, double Median, double Q3, double Maximum, AnsiString XAxisValue)/* overload */;
	void __fastcall AddMultiPoints(double Minimum, double Q1, double Median, double Q3, double Maximum, bool Defined)/* overload */;
	void __fastcall AddMultiPoints(double Minimum, double Q1, double Median, double Q3, double Maximum, System::TDateTime SingleDateTime)/* overload */;
	void __fastcall AddMultiPoints(double Minimum, double Q1, double Median, double Q3, double Maximum, System::TDateTime SingleDateTime, bool Defined)/* overload */;
	void __fastcall AddMultiPoints(double Minimum, double Q1, double Median, double Q3, double Maximum, Graphics::TColor Color)/* overload */;
	void __fastcall AddMultiPoints(double Minimum, double Q1, double Median, double Q3, double Maximum, Graphics::TColor Color, bool Defined)/* overload */;
	void __fastcall AddMultiPoints(double Minimum, double Q1, double Median, double Q3, double Maximum, System::TDateTime SingleDateTime, Graphics::TColor Color)/* overload */;
	void __fastcall AddMultiPoints(double Minimum, double Q1, double Median, double Q3, double Maximum, System::TDateTime SingleDateTime, Graphics::TColor Color, bool Defined)/* overload */;
	System::TDateTime __fastcall GetXTimeStamp(int ValueIndex);
	System::TDateTime __fastcall ConvertDateToXDate(System::TDateTime Date);
	void __fastcall Init(Graphics::TCanvas* Canvas, const Types::TRect &R, double ScaleX, double ScaleY);
	void __fastcall XaxisDrawValue(System::TObject* Sender, TChartSerie* Serie, Graphics::TCanvas* Canvas, const Types::TRect &ARect, int XAxisY, int ValueIndex, int XMarker, bool Top, double ScaleX, double ScaleY, bool DrawCustomValues, bool &defaultdraw);
	int __fastcall GetBarWidth(double ScaleX);
	int __fastcall GetHistogramBarWidth(double ScaleX);
	double __fastcall GetStackedTotal(int I);
	double __fastcall GetStackedPercValue(double sv, int I);
	AnsiString __fastcall GetStackedValueString(int i);
	double __fastcall GetStackedValue(int i);
	double __fastcall GetPrevSerieStackedValue(int PointIndex);
	double __fastcall GetTotalSeriesValuePyramid(int i);
	double __fastcall GetNextValuePyramid(int idx, int i);
	AnsiString __fastcall GetPercentageValue(double SingleValue);
	TChartPoint __fastcall GetChartPoint(int Index);
	int __fastcall GetXYPoint(int X, int Y);
	TChartPoint __fastcall GetChartPointFromDrawPoint(int Index);
	double __fastcall GetTotalPoints(void);
	Types::TRect __fastcall GetPieRectangle(int Index, const Types::TRect &R);
	Types::TPoint __fastcall GetPieCenter(const Types::TRect &pbr);
	Types::TPoint __fastcall GetLegendCenter(const Types::TRect &pbr, int width, int height);
	Types::TPoint __fastcall GetDrawPoint(int Index);
	Types::TPoint __fastcall GetDrawValue(int Index);
	int __fastcall GetAngle(TChartXYAxisText* Text);
	int __fastcall ValueToY(double value, const Types::TRect &R);
	double __fastcall YToValue(int value, const Types::TRect &R);
	int __fastcall ValueToX(double value, const Types::TRect &R);
	double __fastcall XToValue(int value, const Types::TRect &R);
	__property double YScale = {read=FYScale, write=SetYScale};
	__property double OldYScale = {read=FOldYScale, write=SetOldYScale};
	__property double OriginalYScale = {read=FOriginalYScale, write=SetOriginalYScale};
	__property double OffSet = {read=FOffSet, write=SetOffset};
	void __fastcall MoveTo(int SerieIndex);
	double __fastcall GetMaximumValue(void);
	__property int MaximumPoints = {read=FMaximumPoints, write=FMaximumPoints, default=-1};
	__property bool UseFullRange = {read=FUseFullRange, write=FUseFullRange, default=0};
	virtual void __fastcall SaveToFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	virtual void __fastcall LoadFromFile(Inifiles::TMemIniFile* ini, AnsiString Section);
	__property bool ReadOnly = {read=FReadOnly, write=SetReadOnly, default=0};
	
__published:
	__property int Tag = {read=FTag, write=FTag, default=0};
	__property bool DrawFromStartDate = {read=FDrawFromStartDate, write=SetDrawFromStartDate, default=1};
	__property Graphics::TColor ArrowColor = {read=FArrowColor, write=SetArrowColor, default=536870911};
	__property int ArrowSize = {read=FArrowSize, write=SetArrowSize, default=10};
	__property TChartSerieAutoRange AutoRange = {read=FAutoRange, write=SetAutoRange, default=1};
	__property int RangePercentMargin = {read=FRangePercentMargin, write=SetRangePercentMargin, default=5};
	__property TChartSeriePie* Pie = {read=FPie, write=FPie};
	__property TChartAnnotations* Annotations = {read=FAnnotations, write=FAnnotations};
	__property TChartBackGroundPosition ChartPatternPosition = {read=FChartPatternPosition, write=SetChartPatternPosition, default=0};
	__property int BorderWidth = {read=FBorderwidth, write=SetBorderWidth, default=1};
	__property Graphics::TColor BorderColor = {read=FBorderColor, write=SetBorderColor, default=0};
	__property int BorderRounding = {read=FBorderRounding, write=SetBorderRounding, default=0};
	__property Graphics::TBrushStyle BrushStyle = {read=FBrushStyle, write=SetBrushStyle, default=0};
	__property TChartType ChartType = {read=FChartType, write=SetChartType, default=1};
	__property int GroupIndex = {read=FGroupIndex, write=SetGroupIndex, default=0};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=255};
	__property Graphics::TColor ColorTo = {read=FColorTo, write=SetColorTo, default=536870911};
	__property Graphics::TColor CandleColorDecrease = {read=FCandleColorDecrease, write=SetCandleColorDecrease, default=255};
	__property Graphics::TColor CandleColorIncrease = {read=FCandleColorIncrease, write=SetCandleColorIncrease, default=32768};
	__property TChartSerieCrossHairYValue* CrossHairYValue = {read=FCrossHairYValue, write=SetCrossHairYValue};
	__property int GradientSteps = {read=FGradientSteps, write=SetGradientSteps, default=100};
	__property TChartGradientDirection GradientDirection = {read=FGradientDirection, write=SetGradientDirection, default=0};
	__property Graphics::TColor LineColor = {read=FLineColor, write=SetLineColor, default=255};
	__property int LineWidth = {read=FLineWidth, write=SetLineWidth, default=1};
	__property AnsiString LegendText = {read=FLegendText, write=SetLegendText};
	__property bool ShowInLegend = {read=FShowInLegend, write=SetShowInLegend, default=1};
	__property TChartMarker* Marker = {read=FMarker, write=FMarker};
	__property double Maximum = {read=FMax, write=SetMax};
	__property double Minimum = {read=FMin, write=SetMin};
	__property AnsiString Name = {read=FName, write=SetName};
	__property Graphics::TPenStyle PenStyle = {read=FPenStyle, write=SetPenStyle, default=0};
	__property Graphics::TPicture* ChartPattern = {read=FChartPattern, write=SetChartPattern};
	__property bool ShowValue = {read=FShowValue, write=SetShowValue, default=0};
	__property bool ShowValueInTracker = {read=FShowValueInTracker, write=SetShowValueInTracker, default=1};
	__property bool ShowAnnotationsOnTop = {read=FShowAnnotationsOnTop, write=SetShowAnnotationsOnTop, default=0};
	__property Graphics::TFont* ValueFont = {read=FValueFont, write=SetValueFont};
	__property int ValueAngle = {read=FValueAngle, write=SetValueAngle, default=0};
	__property AnsiString ValueFormat = {read=FValueFormat, write=SetValueFormat};
	__property TChartValueType ValueType = {read=FValueType, write=SetValueType, default=1};
	__property TChartValueFormatType ValueFormatType = {read=FValueFormatType, write=SetValueFormatType, default=0};
	__property int ValueWidth = {read=FValueWidth, write=SetValueWidth, default=50};
	__property TChartSerieValueWidthType ValueWidthType = {read=FValueWidthType, write=SetValueWidthType, default=1};
	__property Graphics::TColor WickColor = {read=FWickColor, write=SetWickColor, default=0};
	__property int WickWidth = {read=FWickWidth, write=SetWickWidth, default=1};
	__property TChartSerieXAxis* XAxis = {read=FXAxis, write=SetXAxis};
	__property TChartSerieYAxis* YAxis = {read=FYAxis, write=SetYAxis};
	__property bool ZeroLine = {read=FZeroLine, write=SetZeroLine, default=0};
	__property int ZeroLineWidth = {read=FZeroLineWidth, write=SetZeroLineWidth, default=1};
	__property Graphics::TColor ZeroLineColor = {read=FZeroLineColor, write=SetZeroLineColor, default=536870911};
	__property double ZeroReferencePoint = {read=FZeroReferencePoint, write=SetZeroReferencePoint};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property TChartSerieSliceGetValue OnSerieSliceGetValue = {read=FOnSerieSliceGetValue, write=FOnSerieSliceGetValue};
	__property TChartSerieDrawPoint OnSerieDrawPoint = {read=FOnSerieDrawPoint, write=FOnSerieDrawPoint};
	__property TChartXAxisDrawValue OnXAxisDrawValue = {read=FOnXAxisDrawValue, write=FOnXAxisDrawValue};
	__property TChartAxisGetValue OnXAxisGetValue = {read=FOnXAxisGetValue, write=FOnXAxisGetValue};
	__property TChartXAxisDrawValue OnXAxisDrawXValue = {read=FOnXAxisDrawXValue, write=FOnXAxisDrawXValue};
	__property TChartAxisGetValue OnXAxisGetXValue = {read=FOnXAxisGetXValue, write=FOnXAxisGetXValue};
	__property TChartYAxisDrawValue OnYAxisDrawvalue = {read=FOnYAxisDrawValue, write=FOnYAxisDrawValue};
	__property TChartAxisGetValue OnYAxisGetValue = {read=FOnYAxisGetValue, write=FOnYAxisGetValue};
	__property TChartMarkerDrawEvent OnMarkerDrawValue = {read=FOnMarkerDrawValue, write=FOnMarkerDrawValue};
	__property TChartGetBarValueTextEvent OnGetBarValueText = {read=FOnGetBarValueText, write=FOnGetBarValueText};
	__property TChartSerieMouseEvent OnSerieMouseDown = {read=FOnSerieMouseDown, write=FOnSerieMouseDown};
	__property TChartSerieMouseEvent OnSerieMouseUp = {read=FOnSerieMouseUp, write=FOnSerieMouseUp};
	__property int SelectedIndex = {read=FSelectedIndex, write=SetSelectedIndex, default=-1};
	__property bool SelectedMark = {read=FSelectedMark, write=SetSelectedMark, default=0};
	__property Graphics::TColor SelectedMarkColor = {read=FSelectedColor, write=SetSelectedColor, default=65280};
	__property Graphics::TColor SelectedMarkBorderColor = {read=FSelectedMarkBorderColor, write=SetSelectedMarkBorderColor, default=0};
	__property int SelectedMarkSize = {read=FSelectedMarkSize, write=SetSelectedMarkSize, default=8};
	__property bool Enable3D = {read=FEnable3D, write=SetEnable3D, default=0};
	__property bool Darken3D = {read=FDarken3D, write=SetDarken3D, default=1};
	__property int Offset3D = {read=FOffset3D, write=SetOffset3D, default=20};
	__property TChartBarShape BarShape = {read=FBarShape, write=SetBarShape, default=0};
	__property bool Logarithmic = {read=FLogarithmic, write=SetLogarithmic, default=0};
	__property Graphics::TFont* BarValueTextFont = {read=FBarValueTextFont, write=SetBarValueTextFont};
	__property Classes::TAlignment BarValueTextAlignment = {read=FBarValueTextAlignment, write=SetBarValueTextAlignment, default=0};
	__property TChartBarValueTextType BarValueTextType = {read=FBarValueTextType, write=SetBarValueTextType, default=0};
	__property bool Visible = {read=FVisible, write=SetVisible, default=1};
	__property TChartSerieXAxisGroups* XAxisGroups = {read=FXAxisGroups, write=SetXAxisGroups};
	__property bool XAxisGroupsVisible = {read=FXAxisGroupsVisible, write=SetXAxisGroupsVisible, default=1};
	__property int GanttHeight = {read=FGanttHeight, write=SetGanttHeight, default=25};
	__property int GanttSpacing = {read=FGanttSpacing, write=SetGanttSpacing, default=20};
};


#pragma pack(push, 4)
struct TXAxisRangeValue
{
	int RangeIndex;
	int Serie;
} ;
#pragma pack(pop)

#pragma option push -b-
enum TYAxisRangeValueMode { vmMajor, vmMinor };
#pragma option pop

struct TYAxisRangeValue
{
	int Serie;
	AnsiString ValueStr;
	TYAxisRangeValueMode Mode;
	double Value;
} ;

//-- var, const, procedure ---------------------------------------------------
static const Shortint CROSSHAIRDISTANCE = 0x14;
static const Shortint LOGARITHMICMAX = 0x64;
extern PACKAGE void __fastcall GetLegendPosition(int &x, int &y, int origw, int origh, int objectwidth, int objectheight, TChartLegendAlignment location);
extern PACKAGE double __fastcall ConvertToLog(double Value);
extern PACKAGE Graphics::TColor __fastcall DarkenColor(Graphics::TColor color, bool Apply);

}	/* namespace Advchart */
using namespace Advchart;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// AdvChart
